#ifndef DOWNLOAD_MANAGER_H

#define DOWNLOAD_MANAGER_H

#include "./VideoNetClientDemo_Common.h"

namespace structure
{

	class DownloadInformation
	{
	public:
		DownloadInformation(){}
		~DownloadInformation(){}
		DownloadInformation(const DownloadInformation &obj);
		DownloadInformation& operator=(const DownloadInformation &obj);
		bool operator==(const DownloadInformation &obj);
	public:
		string	m_cDownloadFile;
		string	m_cSaveFile;
	};

	struct IDownloadManagerVisitor
	{
		virtual int DownloadManagerVisitor(HFILE_TRANSFER id, const DownloadInformation &info);
	};

	//ع
	class DownloadManager
	{
	public:
		DownloadManager();
		~DownloadManager();
	public:
		int Insert(HFILE_TRANSFER &id);
		int Remove(HFILE_TRANSFER &id);
		int GetInfo(HFILE_TRANSFER id, DownloadInformation **info);
		int Visit(IDownloadManagerVisitor	*pVisitor);
	protected:
		DISABLE_COPY_CAPABILITY_OBJECT(DownloadManager);
	private:
		typedef pair<HFILE_TRANSFER, DownloadInformation>	PairElement;
		typedef list<PairElement>	ListManager;
		ListManager	m_lsManager;
	};

}

#endif