#ifndef HISTORY_QUERY_MANAGER_H

#define HISTORY_QUERY_MANAGER_H

#include "./VideoNetClientDemo_Common.h"

namespace structure
{

	class HistoryQueryInformation
	{
	public:
		HistoryQueryInformation(){}
		~HistoryQueryInformation(){}
		HistoryQueryInformation(const HistoryQueryInformation &obj);
		HistoryQueryInformation& operator=(const HistoryQueryInformation &obj);
		bool operator==(const HistoryQueryInformation &obj);
	public:
		DWORD	m_Channel;
		DWORD	m_QueryType;
		DWORD	m_MainType;
		DWORD	m_AssistType;
		DWORD	m_DiskGroup;
		SYSTEMTIME	m_StartTime;
		SYSTEMTIME	m_StopTime;
		string	m_Record;
	};

	struct IHistoryQueryManagerVisitor
	{
		virtual int HistoryQueryManagerVisitor(HSTREAM_QUERY id, const HistoryQueryInformation &info);
	};

	//ʷѯ
	class HistoryQueryManager
	{
	public:
		HistoryQueryManager();
		~HistoryQueryManager();
	public:
		int Insert(HSTREAM_QUERY &id);
		int Remove(HSTREAM_QUERY &id);
		int GetInfo(HSTREAM_QUERY id, HistoryQueryInformation **info);
		int Visit(IHistoryQueryManagerVisitor	*pVisitor);
	protected:
		DISABLE_COPY_CAPABILITY_OBJECT(HistoryQueryManager);
	private:
		typedef pair<HSTREAM_QUERY, HistoryQueryInformation>	PairElement;
		typedef list<PairElement>	ListManager;
		ListManager	m_lsManager;
	};

}

#endif