#ifndef HISTORY_STREAM_MANAGER_H

#define HISTORY_STREAM_MANAGER_H

#include "./VideoNetClientDemo_Common.h"
#include "./OutputToFile.h"

namespace structure
{

	class HistoryStreamInformation
	{
	public:
		HistoryStreamInformation(){}
		~HistoryStreamInformation(){}
		HistoryStreamInformation(const HistoryStreamInformation &obj);
		HistoryStreamInformation& operator=(const HistoryStreamInformation &obj);
		bool operator==(const HistoryStreamInformation &obj);
	public:
		DWORD	m_Channel;
		DWORD	m_QueryType;
		DWORD	m_Protocol;
		DWORD	m_Group;
		string	m_Record;
		SYSTEMTIME	m_StartTime;
		SYSTEMTIME	m_StopTime;
	};

	//˶󲻿ɿ,ʹʱע
	class HistoryStreamInfoManager
	{
	public:
		HistoryStreamInfoManager(){}
		~HistoryStreamInfoManager(){}
		HistoryStreamInfoManager(const HistoryStreamInfoManager &obj){(*this) = obj;}
		HistoryStreamInfoManager& operator=(const HistoryStreamInfoManager &obj);
		bool operator==(const HistoryStreamInfoManager &obj);
	public:
		HistoryStreamInformation	m_StreamInfo;
		common::COutputToFile	m_StreamOutput;
	};

	struct IHistoryStreamManagerVisitor
	{
		virtual int HistoryStreamManagerVisitor(HHISTORY id, const HistoryStreamInfoManager &info);
	};

	//ʷ
	class HistoryStreamManager
	{
	public:
		HistoryStreamManager();
		~HistoryStreamManager();
	public:
		int Insert(HHISTORY &id);
		int Remove(HHISTORY &id);
		int Stream(HSTREAM id, char *buffer, int length);
		int GetInfo(HHISTORY id, HistoryStreamInfoManager **info);
		int Visit(IHistoryStreamManagerVisitor	*pVisitor);
	protected:
		DISABLE_COPY_CAPABILITY_OBJECT(HistoryStreamManager);
	private:
		typedef pair<HHISTORY, HistoryStreamInfoManager>	PairElement;
		typedef list<PairElement>	ListManager;
		ListManager	m_lsManager;
	};

}

#endif