#ifndef TALK_STREAM_MANAGER_H

#define TALK_STREAM_MANAGER_H

#include "./VideoNetClientDemo_Common.h"
#include "./OutputToFile.h"
#include "./Thread.h"

namespace structure
{

	class TalkStreamInformation
	{
	public:
		TalkStreamInformation(){}
		~TalkStreamInformation(){}
		TalkStreamInformation(const TalkStreamInformation &obj);
		TalkStreamInformation& operator=(const TalkStreamInformation &obj);
		bool operator==(const TalkStreamInformation &obj);
	public:
		DWORD	m_Protocol;
		string	m_cRecvFile;
		string	m_cSendFile;
	};

	//˶󲻿ɿ,ʹʱע
	class TalkStreamInfoManager : public common::IThreadExecute
	{
	public:
		TalkStreamInfoManager(){}
		~TalkStreamInfoManager(){}
		TalkStreamInfoManager(const TalkStreamInfoManager &obj){(*this) = obj;}
		TalkStreamInfoManager& operator=(const TalkStreamInfoManager &obj);
		bool operator==(const TalkStreamInfoManager &obj);
	public:
		//
		int Start();
		//ֹͣ
		int Stop();
		//ִ߳
		int execute();
	public:
		HSTREAM					m_hStream;
		TalkStreamInformation	m_StreamInfo;
		common::COutputToFile	m_StreamOutput;
		common::CThread			m_SendThread;
	};

	struct ITalkStreamManagerVisitor
	{
		virtual int TalkStreamManagerVisitor(HSTREAM id, const TalkStreamInfoManager &TalkStream);
	};

	//
	class TalkStreamManager
	{
	public:
		TalkStreamManager();
		~TalkStreamManager();
	public:
		int Insert(HSTREAM &id);
		int Remove(HSTREAM &id);
		int Stream(HSTREAM id, char *buffer, int length);
		int GetInfo(HSTREAM id, TalkStreamInfoManager **TalkStream);
		int Visit(ITalkStreamManagerVisitor	*pVisitor);
	protected:
		DISABLE_COPY_CAPABILITY_OBJECT(TalkStreamManager);
	private:
		typedef pair<HSTREAM, TalkStreamInfoManager>	PairTalkStream;
		typedef list<PairTalkStream>	ListTalkStreamManager;
		ListTalkStreamManager	m_lsTalkStreamManager;
	};

}

#endif