#ifndef TRANSPARENT_MANAGER_H

#define TRANSPARENT_MANAGER_H

#include "./VideoNetClientDemo_Common.h"
#include "./OutputToFile.h"
#include "./Thread.h"

namespace structure
{

	class TransparentInformation
	{
	public:
		TransparentInformation(){}
		~TransparentInformation(){}
		TransparentInformation(const TransparentInformation &obj);
		TransparentInformation& operator=(const TransparentInformation &obj);
		bool operator==(const TransparentInformation &obj);
	public:
		DWORD	m_ChannelType;
		DWORD	m_SerialPort;
		DWORD	m_SerialType;
		string	m_cRecvFile;
		string	m_cSendFile;
	};

	//˶󲻿ɿ,ʹʱע
	class TransparentInfoManager : public common::IThreadExecute
	{
	public:
		TransparentInfoManager(){}
		~TransparentInfoManager(){}
		TransparentInfoManager(const TransparentInfoManager &obj){(*this) = obj;}
		TransparentInfoManager& operator=(const TransparentInfoManager &obj);
		bool operator==(const TransparentInfoManager &obj);
	public:
		//
		int Start();
		//ֹͣ
		int Stop();
		//ִ߳
		int execute();
	public:
		HTRANSPARENT			m_hStream;
		TransparentInformation	m_StreamInfo;
		common::COutputToFile	m_StreamOutput;
		common::CThread			m_SendThread;
	};

	struct ITransparentManagerVisitor
	{
		virtual int TransparentManagerVisitor(HTRANSPARENT id, const TransparentInfoManager &info);
	};

	//͸ͨ
	class TransparentManager
	{
	public:
		TransparentManager();
		~TransparentManager();
	public:
		int Insert(HTRANSPARENT &id);
		int Remove(HTRANSPARENT &id);
		int Stream(HTRANSPARENT id, char *buffer, int length);
		int GetInfo(HTRANSPARENT id, TransparentInfoManager **info);
		int Visit(ITransparentManagerVisitor	*pVisitor);
	protected:
		DISABLE_COPY_CAPABILITY_OBJECT(TransparentManager);
	private:
		typedef pair<HTRANSPARENT, TransparentInfoManager>	PairElement;
		typedef list<PairElement>	ListManager;
		ListManager	m_lsManager;
	};

}

#endif