
#include "../platform/win32/inc/stdafx.h"
#include "../inc/HistoryQueryManager.h"

#include "../inc/Utility.h"
using namespace common;

namespace structure
{

	HistoryQueryInformation::HistoryQueryInformation(const HistoryQueryInformation &obj)
	{
		(*this) = obj;
	}

	HistoryQueryInformation& HistoryQueryInformation::operator=(const HistoryQueryInformation &obj)
	{
		this->m_Channel = obj.m_Channel;
		this->m_QueryType = obj.m_QueryType;
		this->m_MainType = obj.m_MainType;
		this->m_AssistType = obj.m_AssistType;
		this->m_DiskGroup = obj.m_DiskGroup;
		this->m_StartTime = obj.m_StartTime;
		this->m_StopTime = obj.m_StopTime;
		this->m_Record = obj.m_Record;
		return (*this);
	}

	bool HistoryQueryInformation::operator==(const HistoryQueryInformation &obj)
	{
		CUtility	cUtility;
		if (this->m_Channel != obj.m_Channel ||
			this->m_Record != obj.m_Record ||
			this->m_QueryType != obj.m_QueryType ||
			this->m_MainType != obj.m_MainType ||
			this->m_AssistType != obj.m_AssistType ||
			this->m_DiskGroup != obj.m_DiskGroup ||
			(0 != cUtility.CompareTime(this->m_StartTime, obj.m_StartTime)) ||
			(0 != cUtility.CompareTime(this->m_StopTime, obj.m_StopTime)))
		{
			return false;
		}
		return true;
	}

	//ʷѯ
	HistoryQueryManager::HistoryQueryManager()
	{
		m_lsManager.clear();
	}

	HistoryQueryManager::~HistoryQueryManager()
	{
		m_lsManager.clear();
	}

	int HistoryQueryManager::Insert(HSTREAM_QUERY &id)
	{
		PairElement element;
		element.first = id;
		//豸
		m_lsManager.push_back(element);
		return 0;
	}

	int HistoryQueryManager::Remove(HSTREAM_QUERY &id)
	{
		for (ListManager::iterator iter = m_lsManager.begin(); iter != m_lsManager.end();iter++)
		{
			if (id == iter->first)
			{
				m_lsManager.erase(iter);
				return 0;
			}
		}
		return 1;
	}

	int HistoryQueryManager::GetInfo(HSTREAM id, HistoryQueryInformation **info)
	{
		for (ListManager::iterator iter = m_lsManager.begin(); iter != m_lsManager.end();iter++)
		{
			if (id == iter->first)
			{
				(*info) = &(iter->second);
				return 0;
			}
		}
		return 1;
	}

	int HistoryQueryManager::Visit(IHistoryQueryManagerVisitor	*pVisitor)
	{
		for (ListManager::iterator iter = m_lsManager.begin(); iter != m_lsManager.end();iter++)
		{
			pVisitor->HistoryQueryManagerVisitor(iter->first, iter->second);
		}
		return 0;
	}

}
