
#include "../platform/win32/inc/stdafx.h"
#include "../inc/HistoryStreamManager.h"

#include "../inc/Utility.h"
using namespace common;

namespace structure
{

	HistoryStreamInformation::HistoryStreamInformation(const HistoryStreamInformation &obj)
	{
		(*this) = obj;
	}

	HistoryStreamInformation& HistoryStreamInformation::operator=(const HistoryStreamInformation &obj)
	{
		this->m_Channel = obj.m_Channel;
		this->m_QueryType = obj.m_QueryType;
		this->m_Protocol = obj.m_Protocol;
		this->m_Group = obj.m_Group;
		this->m_Record = obj.m_Record;
		this->m_StartTime = obj.m_StartTime;
		this->m_StopTime = obj.m_StopTime;
		return (*this);
	}

	bool HistoryStreamInformation::operator==(const HistoryStreamInformation &obj)
	{
		CUtility	cUtility;
		if (this->m_Channel != obj.m_Channel ||
			this->m_QueryType != obj.m_QueryType ||
			this->m_Protocol != obj.m_Protocol ||
			this->m_Group != obj.m_Group ||
			this->m_Record != obj.m_Record ||
			(0 != cUtility.CompareTime(this->m_StartTime, obj.m_StartTime)) ||
			(0 != cUtility.CompareTime(this->m_StopTime, obj.m_StopTime)))
		{
			return false;
		}
		return true;
	}

	HistoryStreamInfoManager& HistoryStreamInfoManager::operator=(const HistoryStreamInfoManager &obj)
	{
		this->m_StreamInfo = obj.m_StreamInfo;
		return (*this);
	}

	bool HistoryStreamInfoManager::operator==(const HistoryStreamInfoManager &obj)
	{
		if (this->m_StreamInfo == obj.m_StreamInfo)
		{
			return true;
		}
		return false;
	}

	//ʷ
	HistoryStreamManager::HistoryStreamManager()
	{
		m_lsManager.clear();
	}

	HistoryStreamManager::~HistoryStreamManager()
	{
		m_lsManager.clear();
	}

	int HistoryStreamManager::Insert(HHISTORY &id)
	{
		PairElement element;
		element.first = id;
		//豸
		m_lsManager.push_back(element);
		return 0;
	}

	int HistoryStreamManager::Remove(HHISTORY &id)
	{
		for (ListManager::iterator iter = m_lsManager.begin(); iter != m_lsManager.end();iter++)
		{
			if (id == iter->first)
			{
				m_lsManager.erase(iter);
				return 0;
			}
		}
		return 1;
	}

	int HistoryStreamManager::Stream(HSTREAM id, char *buffer, int length)
	{
		for (ListManager::iterator iter = m_lsManager.begin(); iter != m_lsManager.end();iter++)
		{
			if (id == iter->first)
			{
				if (CHECK_RET_FAILED(iter->second.m_StreamOutput.IsValid()))
				{
					if (0 == iter->second.m_StreamInfo.m_Record.size())
					{
						return 1;
					}
					if (CHECK_RET_FAILED(iter->second.m_StreamOutput.Open(iter->second.m_StreamInfo.m_Record, true)))
					{
						return 1;
					}
					CUtility	cUtility;
					char *header = NULL;
					int headlen = 0;
					cUtility.GetRecordFileHeader(&header, headlen);
					iter->second.m_StreamOutput.Output(header, headlen);
				}
				return iter->second.m_StreamOutput.Output(buffer, length);
			}
		}
		return 1;
	}

	int HistoryStreamManager::GetInfo(HSTREAM id, HistoryStreamInfoManager **info)
	{
		for (ListManager::iterator iter = m_lsManager.begin(); iter != m_lsManager.end();iter++)
		{
			if (id == iter->first)
			{
				(*info) = &(iter->second);
				return 0;
			}
		}
		return 1;
	}

	int HistoryStreamManager::Visit(IHistoryStreamManagerVisitor	*pVisitor)
	{
		for (ListManager::iterator iter = m_lsManager.begin(); iter != m_lsManager.end();iter++)
		{
			pVisitor->HistoryStreamManagerVisitor(iter->first, iter->second);
		}
		return 0;
	}

}
