// LogQueryDlg.cpp : ʵļ
//

#include "../platform/win32/inc/stdafx.h"
#include "../inc/VideoNetClientDemo_Common.h"
#include "../inc/LogQueryDlg.h"

#include "../inc/Utility.h"
using namespace common;

#include "../inc/VideoNetClientDemoDlg.h"

extern CVideoNetClientDemoDlg	*g_pMainDialog;

// CLogQueryDlg Ի

IMPLEMENT_DYNAMIC(CLogQueryDlg, CDialog)

CLogQueryDlg::CLogQueryDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CLogQueryDlg::IDD, pParent)
{

}

CLogQueryDlg::~CLogQueryDlg()
{
}

void CLogQueryDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_CBCHANNEL, m_CBChannel);
	DDX_Control(pDX, IDC_CBMAINTYPE, m_CBMainType);
	DDX_Control(pDX, IDC_CBASSISTTYPE, m_CBAssistType);
	DDX_Control(pDX, IDC_CBQUERYMODE, m_CBQueryMode);
	DDX_Control(pDX, IDC_STARTDATE, m_DTStartDate);
	DDX_Control(pDX, IDC_STOPDATE, m_DTStopDate);
	DDX_Control(pDX, IDC_LSRESULT, m_LSResult);
}


BEGIN_MESSAGE_MAP(CLogQueryDlg, CDialog)
	ON_BN_CLICKED(IDC_BTCONFIRM, &CLogQueryDlg::OnBnClickedBtconfirm)
END_MESSAGE_MAP()


// CLogQueryDlg Ϣ

BOOL CLogQueryDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// TODO:  ڴӶĳʼ
	ListView_SetExtendedListViewStyle(m_LSResult.m_hWnd,LVS_EX_GRIDLINES);//ʾ
	::SendMessage(m_LSResult.m_hWnd, LVM_SETEXTENDEDLISTVIEWSTYLE, LVS_EX_FULLROWSELECT, LVS_EX_FULLROWSELECT);
	m_LSResult.InsertColumn(0, "time", LVCFMT_LEFT, 70);//ʼб
	m_LSResult.InsertColumn(1, "main", LVCFMT_LEFT, 60);
	m_LSResult.InsertColumn(2, "assist", LVCFMT_LEFT, 70);
	m_LSResult.InsertColumn(3, "info", LVCFMT_LEFT, 160);
	m_LSResult.InsertColumn(4, "user", LVCFMT_LEFT, 70);
	m_LSResult.InsertColumn(5, "user ip", LVCFMT_LEFT, 100);

	CString	cChannel;
	cChannel.Format("All");
	m_CBChannel.AddString(cChannel);
	for (int count = 0; count < MAX_CHANNEL_NUMBER; count++)
	{
		cChannel.Format("CH %d", count + 1);
		m_CBChannel.AddString(cChannel);
	}
	if (0 < m_CBChannel.GetCount())
	{
		m_CBChannel.SetCurSel(0);
	}

	CString cMainType[] = {"System Manage", "System Config", "Record", "User Manager", "Alarm", "Exception", "Store", "All"};
	for (int count = 0; count < ARRAY_ELEMENT_COUNT(cMainType); count++)
	{
		m_CBMainType.AddString(cMainType[count]);
	}
	if (0 < m_CBMainType.GetCount())
	{
		m_CBMainType.SetCurSel(0);
	}

	CString cAssistType[] = {"All"};
	for (int count = 0; count < ARRAY_ELEMENT_COUNT(cAssistType); count++)
	{
		m_CBAssistType.AddString(cAssistType[count]);
	}
	if (0 < m_CBAssistType.GetCount())
	{
		m_CBAssistType.SetCurSel(0);
	}

	CString cQueryMode[] = {"Default"};
	for (int count = 0; count < ARRAY_ELEMENT_COUNT(cQueryMode); count++)
	{
		m_CBQueryMode.AddString(cQueryMode[count]);
	}
	if (0 < m_CBQueryMode.GetCount())
	{
		m_CBQueryMode.SetCurSel(0);
	}

	// ʱؼ
	m_DTStartDate.SetFormat(_T("yyyy-MM-dd HH:mm:ss"));
	m_DTStopDate.SetFormat(_T("yyyy-MM-dd HH:mm:ss"));
	return TRUE;  // return TRUE unless you set the focus to a control
	// 쳣: OCX ҳӦ FALSE
}

void CLogQueryDlg::OnBnClickedBtconfirm()
{
	// TODO: ڴӿؼ֪ͨ

	UpdateData();
	CString cMainType[7] = {"ϵͳ־", "ϵͳ־", "¼־", "û־", "־", "쳣־", "洢־"};
	CString cAssistType[7][20] = {
	{"", "̨", "Ƿػ", "ػ", "", "Զ", ""},
	{"¼ʱ", "ͨ", "", "", "", "ƶ", "̨", "ָĬ", "ʾ豸", "ʾģʽãģʽ", "ͼɫ", "Զά", "", "", "ܶ", "PTZЭ", "PTZЭ", "", "", "쳣"},
	{"IPͻ", "Ӳ", "Ӳ̴", "Ƿ", "źŶʧ", "źŻָ", "߶"},
	{"û", "ɾû", "޸û", "½", "ע"},
	{"ƶⱨʼ", "ƶⱨʼ", "뱨ʼ"},
	{"ʽ", "ӷ", "ɾ", "жӲ", ""},
	{"ֶ¼ʼ", "Զ¼ʼ", "¼"}};

	HLOG_QUERY hFileQuery;
	LogQueryFactor	cFactor;

	CUtility cUtility;
	SYSTEMTIME	systime;
	cUtility.TimeFormControl(systime, m_DTStartDate);
	cUtility.TimeToString(cFactor.m_sStartTime, systime);
	cUtility.TimeFormControl(systime, m_DTStopDate);
	cUtility.TimeToString(cFactor.m_sStopTime, systime);
	cFactor.m_dwChannel = m_CBChannel.GetCurSel();
	cFactor.m_eMajorType = (eHistoryLogMajorType)(m_CBMainType.GetCurSel() + 1);
	cFactor.m_eMinorType = (eHistoryLogMinorType)(m_CBAssistType.GetCurSel());
	cFactor.m_dwQueryMode = m_CBQueryMode.GetCurSel();

	if (CHECK_RET_FAILED(g_pMainDialog->LogQueryConnect(&hFileQuery, &cFactor)))
	{
		return;
	}
	m_LSResult.DeleteAllItems();
	LogQueryResult	cResult;

	CString str;
	while (CHECK_RET_SUCCESS(g_pMainDialog->LogQueryNext(hFileQuery, &cResult)))
	{
		int count = m_LSResult.InsertItem(0xFFFF, "");
		str.Format("%s", cResult.m_sLogTime);
		m_LSResult.SetItem(count, 0, 1 , str, NULL, 0, 0, 0);
		str.Format("%s", cMainType[cResult.m_eMajorType]);
		m_LSResult.SetItem(count, 1, 1 , str, NULL, 0, 0, 0);
		str.Format("%s", cAssistType[cResult.m_eMajorType - 1][cResult.m_eMinorType]);
		m_LSResult.SetItem(count, 2, 1 , str, NULL, 0, 0, 0);
		str.Format("%d", cResult.m_dwDetailInfo);
		m_LSResult.SetItem(count, 3, 1 , str, NULL, 0, 0, 0);
		str.Format("%s", cResult.m_sUserName);
		m_LSResult.SetItem(count, 4, 1 , str, NULL, 0, 0, 0);
		str.Format("%s", cResult.m_sUserIP);
		m_LSResult.SetItem(count, 5, 1 , str, NULL, 0, 0, 0);
	}
	g_pMainDialog->LogQueryDisconnect(hFileQuery);
}
