
#include "../platform/win32/inc/stdafx.h"
#include "../inc/OutputToFile.h"

namespace common
{

	COutputToFile::COutputToFile()
	{
		m_bOutput = false;
		m_strFile.clear();
	}

	COutputToFile::~COutputToFile()
	{
		Close();
	}

	int COutputToFile::Open(string file, bool binary)
	{
		if (0 == file.size())
		{
			return 1;
		}
		if (m_bOutput)
		{
			return 0;
		}
		ios_base::openmode mode = ios_base::out | ios_base::trunc;
		if (binary)
		{
			mode = mode | ios_base::binary;
		}
		m_file.open(file.c_str(), mode);
		if (!m_file)
		{
			return 1;
		}
		m_bOutput = true;
		return 0;
	}

	int COutputToFile::Close()
	{
		if (!m_bOutput)
		{
			return 0;
		}
		m_bOutput = false;
		m_strFile.empty();
		m_file.close();
		return 0;
	}

	int COutputToFile::Output(const char *buffer, int ilen)
	{
		if (CHECK_POINT_NULL(buffer) || 0 == ilen || !m_bOutput)
		{
			return 1;
		}
		m_file.write(buffer, ilen);
		m_file.flush();
		return 0;
	}

	int COutputToFile::IsValid()
	{
		return m_bOutput ? 0 : 1;
	}

}