
#include "../platform/win32/inc/stdafx.h"
#include "../inc/UploadManager.h"

namespace structure
{

	UploadInformation::UploadInformation(const UploadInformation &obj)
	{
		(*this) = obj;
	}

	UploadInformation& UploadInformation::operator=(const UploadInformation &obj)
	{
		this->m_cUploadFile = obj.m_cUploadFile;
		return (*this);
	}

	bool UploadInformation::operator==(const UploadInformation &obj)
	{
		if (this->m_cUploadFile != obj.m_cUploadFile)
		{
			return false;
		}
		return true;
	}

	//ع
	UploadManager::UploadManager()
	{
		m_lsManager.clear();
	}

	UploadManager::~UploadManager()
	{
		m_lsManager.clear();
	}

	int UploadManager::Insert(HFILE_TRANSFER &id)
	{
		PairElement element;
		element.first = id;
		//
		m_lsManager.push_back(element);
		return 0;
	}

	int UploadManager::Remove(HFILE_TRANSFER &id)
	{
		for (ListManager::iterator iter = m_lsManager.begin(); iter != m_lsManager.end();iter++)
		{
			if (id == iter->first)
			{
				m_lsManager.erase(iter);
				return 0;
			}
		}
		return 1;
	}

	int UploadManager::GetInfo(HSTREAM id, UploadInformation **info)
	{
		for (ListManager::iterator iter = m_lsManager.begin(); iter != m_lsManager.end();iter++)
		{
			if (id == iter->first)
			{
				(*info) = &(iter->second);
				return 0;
			}
		}
		return 1;
	}

	int UploadManager::Visit(IUploadManagerVisitor	*pVisitor)
	{
		for (ListManager::iterator iter = m_lsManager.begin(); iter != m_lsManager.end();iter++)
		{
			pVisitor->UploadManagerVisitor(iter->first, iter->second);
		}
		return 0;
	}

}
