
#include "../platform/win32/inc/stdafx.h"
#include "../inc/UserManager.h"

namespace structure
{

	UserInformation::UserInformation(const UserInformation &obj)
	{
		(*this) = obj;
	}

	UserInformation& UserInformation::operator=(const UserInformation &obj)
	{
		this->m_cUserName = obj.m_cUserName;
		this->m_cPassWord = obj.m_cPassWord;
		return (*this);
	}

	bool UserInformation::operator==(const UserInformation &obj)
	{
		if (this->m_cUserName != obj.m_cUserName ||
			this->m_cPassWord != obj.m_cPassWord)
		{
			return false;
		}
		return true;
	}

	UserEventInformation::UserEventInformation()
	{
		for (int count = 0; count < ARRAY_ELEMENT_COUNT(m_EventSubscribe); count++)
		{
			this->m_EventSubscribe[count] = false;
		}
	}

	UserEventInformation::UserEventInformation(const UserEventInformation &obj)
	{
		(*this) = obj;
	}

	UserEventInformation& UserEventInformation::operator=(const UserEventInformation &obj)
	{
		for (int count = 0; count < ARRAY_ELEMENT_COUNT(m_EventSubscribe); count++)
		{
			this->m_EventSubscribe[count] = obj.m_EventSubscribe[count];
		}
		return (*this);
	}

	bool UserEventInformation::operator==(const UserEventInformation &obj)
	{
		for (int count = 0; count < ARRAY_ELEMENT_COUNT(m_EventSubscribe); count++)
		{
			if (this->m_EventSubscribe[count] != obj.m_EventSubscribe[count])
			{
				return false;
			}
		}
		return true;
	}

	UserInfoManager::UserInfoManager(const UserInfoManager &obj)
	{
		(*this) = obj;
	}

	UserInfoManager& UserInfoManager::operator=(const UserInfoManager &obj)
	{
		this->m_cUserInformation = obj.m_cUserInformation;
		this->m_cUserEventInformation = obj.m_cUserEventInformation;
		return (*this);
	}

	bool UserInfoManager::operator==(const UserInfoManager &obj)
	{
		if (this->m_cUserInformation == obj.m_cUserInformation &&
			this->m_cUserEventInformation == obj.m_cUserEventInformation)
		{
			return true;
		}
		return false;
	}

	//û
	UserManager::UserManager()
	{
		m_lsUserManager.clear();
	}

	UserManager::~UserManager()
	{
		m_lsUserManager.clear();
	}

	int UserManager::Insert(HUSER &id)
	{
		PairUser cUser;
		cUser.first = id;
		//豸
		m_lsUserManager.push_back(cUser);
		return 0;
	}

	int UserManager::Remove(HUSER &id)
	{
		for (ListUserManager::iterator iter = m_lsUserManager.begin(); iter != m_lsUserManager.end();iter++)
		{
			if (id == iter->first)
			{
				m_lsUserManager.erase(iter);
				return 0;
			}
		}
		return 1;
	}

	int UserManager::SetDevice(string strDevice)
	{
		m_Device = strDevice;
		return 0;
	}

	int UserManager::GetDevice(string &strDevice)
	{
		strDevice = m_Device;
		return 0;
	}

	int UserManager::GetUserInfo(HUSER &id, UserInfoManager **info)
	{
		for (ListUserManager::iterator iter = m_lsUserManager.begin(); iter != m_lsUserManager.end();iter++)
		{
			if (id == iter->first)
			{
				(*info) = &(iter->second);
				return 0;
			}
		}
		return 1;
	}

	int UserManager::GetRealStream(HUSER &id, RealStreamManager **stream)
	{
		UserInfoManager *info = NULL;
		if (CHECK_RET_FAILED(GetUserInfo(id, &info)))
		{
			return 1;
		}
		(*stream) = &(info->m_cRealStreamManager);
		return 0;
	}

	int UserManager::GetTalkStream(HUSER &id, TalkStreamManager **stream)
	{
		UserInfoManager *info = NULL;
		if (CHECK_RET_FAILED(GetUserInfo(id, &info)))
		{
			return 1;
		}
		(*stream) = &(info->m_cTalkStreamManager);
		return 0;
	}

	int UserManager::GetHistoryQuery(HUSER &id, HistoryQueryManager **stream)
	{
		UserInfoManager *info = NULL;
		if (CHECK_RET_FAILED(GetUserInfo(id, &info)))
		{
			return 1;
		}
		(*stream) = &(info->m_cHistoryQueryManager);
		return 0;
	}

	int UserManager::GetHistoryStream(HUSER &id, HistoryStreamManager **stream)
	{
		UserInfoManager *info = NULL;
		if (CHECK_RET_FAILED(GetUserInfo(id, &info)))
		{
			return 1;
		}
		(*stream) = &(info->m_cHistoryStreamManager);
		return 0;
	}

	int UserManager::GetTransparent(HUSER &id, TransparentManager **stream)
	{
		UserInfoManager *info = NULL;
		if (CHECK_RET_FAILED(GetUserInfo(id, &info)))
		{
			return 1;
		}
		(*stream) = &(info->m_cTransparentManager);
		return 0;
	}

	int UserManager::GetDownload(HUSER &id, DownloadManager **stream)
	{
		UserInfoManager *info = NULL;
		if (CHECK_RET_FAILED(GetUserInfo(id, &info)))
		{
			return 1;
		}
		(*stream) = &(info->m_cDownloadManager);
		return 0;
	}

	int UserManager::GetUpload(HUSER &id, UploadManager **stream)
	{
		UserInfoManager *info = NULL;
		if (CHECK_RET_FAILED(GetUserInfo(id, &info)))
		{
			return 1;
		}
		(*stream) = &(info->m_cUploadManager);
		return 0;
	}

	int UserManager::Visit(IUserManagerVisitor	*pVisitor)
	{
		for (ListUserManager::iterator iter = m_lsUserManager.begin(); iter != m_lsUserManager.end();iter++)
		{
			pVisitor->UserManagerVisitor(iter->first, iter->second);
		}
		return 0;
	}

}
