#include "../platform/win32/inc/stdafx.h"
#include "../inc/Utility.h"

namespace common
{

	CUtility::CUtility(void)
	{
	}

	CUtility::~CUtility(void)
	{
	}

	//ѡĿ¼
	int CUtility::SelectDirectory(CString &cDirectory, HWND hParent)
	{
		CString str;
		BROWSEINFO bi;
		ZeroMemory(&bi, sizeof(BROWSEINFO));
		char szPathName[MAX_PATH] = "\0";
		char szTitle[] = "Select Directory";

		bi.hwndOwner = hParent;
		bi.pszDisplayName = szPathName;
		bi.lpszTitle = szTitle;
		bi.ulFlags = BIF_STATUSTEXT;

		LPITEMIDLIST idl = SHBrowseForFolder(&bi);
		if(NULL == idl)
		{
			return 1;
		}

		if (!SHGetPathFromIDList(idl, str.GetBuffer(MAX_PATH * 2)))
		{
			return 1;
		}

		str.ReleaseBuffer();
		if(!str.IsEmpty() && str.GetAt(str.GetLength() - 1) != '\\')
		{
			str += "\\";
		}
		cDirectory = str;
		return 0;
	}

	//ѡļ
	int CUtility::SelectFile(CString &cFile)
	{
		const char pszFilter[] = _T("All Files (*.*)|*.*||");
		CFileDialog cFileDialog(TRUE, NULL, NULL, OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, pszFilter);
		if (IDOK != cFileDialog.DoModal())
		{
			return 1;
		}
		cFile = cFileDialog.GetPathName();
		return 0;
	}

	//ȡ¼ļͷ
	int CUtility::GetRecordFileHeader(char **buffer, int &length)
	{
// 		static BYTE DSPHeader[MAX_FILE_HEADER_LENGTH] = {0X00,0X00,01,0XC6,0X4D ,0X50 ,0X47, 0X34, 0x01, 0x00 ,0X19 ,0X20 ,0XA1 ,0x07 ,0x00 ,0X60 ,0x01, 0X20, 0x01};
// 		(*buffer) = (char*)DSPHeader;
// 		length = sizeof(DSPHeader);


static BYTE pBuffer[MAX_FILE_HEADER_LENGTH];
		// ļʼ
		pBuffer[0] = (BYTE)0x00;
		pBuffer[1] = (BYTE)0x00;
		pBuffer[2] = (BYTE)0x01;
		pBuffer[3] = (BYTE)0xB6;

		// ļID
		pBuffer[4] = (BYTE)0x48;
		pBuffer[5] = (BYTE)0x32;
		pBuffer[6] = (BYTE)0x36;
		pBuffer[7] = (BYTE)0x34;

		// ļͷĳ
		pBuffer[8] = (BYTE)0x00;
		pBuffer[9] = (BYTE)0x00;
		pBuffer[10] = (BYTE)0x00;
		pBuffer[11] = (BYTE)0x13;

		// 汾
		pBuffer[12] = (BYTE)0x01;

		// ݰϢ
		pBuffer[13] = (BYTE)0x01;
		pBuffer[14] = (BYTE)0x00;

		// 
		pBuffer[15] = (BYTE)0x60;
		pBuffer[16] = (BYTE)0x01;

		// 
		pBuffer[17] = (BYTE)0x20;
		pBuffer[18] = (BYTE)0x01;
		(*buffer) = (char*)pBuffer;
		length = sizeof(pBuffer);

		return 0;
	}

	//¼ļ(ԭ¼ļ·'\\'ַ)
	int CUtility::BuildRecordFile(CString &file, const char *device, DWORD channel, const char *type)
	{
		CString strInfo;
		CString strTime;
		SYSTEMTIME systime;
		GetLocalTime(&systime);
		TimeToString(&strTime, systime);
		strInfo.Format("%s%s_%d_%s.%s", file, device, channel, strTime, type);
		file = strInfo;
		return 0;
	}

	//Ƚʱ
	int CUtility::CompareTime(const SYSTEMTIME &first, const SYSTEMTIME &second)
	{
		int iCompare = (first.wYear == second.wYear ? 0 : (first.wYear > second.wYear ? 2 : 1));
		if (0 != iCompare)
		{
			return iCompare;
		}
		iCompare = (first.wMonth == second.wMonth ? 0 : (first.wMonth > second.wMonth ? 2 : 1));
		if (0 != iCompare)
		{
			return iCompare;
		}
		iCompare = (first.wDay == second.wDay ? 0 : (first.wDay > second.wDay ? 2 : 1));
		if (0 != iCompare)
		{
			return iCompare;
		}
		iCompare = (first.wHour == second.wHour ? 0 : (first.wHour > second.wHour ? 2 : 1));
		if (0 != iCompare)
		{
			return iCompare;
		}
		iCompare = (first.wMinute == second.wMinute ? 0 : (first.wMinute > second.wMinute ? 2 : 1));
		if (0 != iCompare)
		{
			return iCompare;
		}
		iCompare = (first.wSecond == second.wSecond ? 0 : (first.wSecond > second.wSecond ? 2 : 1));
		if (0 != iCompare)
		{
			return iCompare;
		}
		iCompare = (first.wMilliseconds == second.wMilliseconds ? 0 : (first.wMilliseconds > second.wMilliseconds ? 2 : 1));
		if (0 != iCompare)
		{
			return iCompare;
		}
		return 0;
	}

	//תʱ
	int CUtility::TimeFormControl(SYSTEMTIME &time, const CDateTimeCtrl &control)
	{
		if (0 == control.GetTime(&time))
		{
			return 1;
		}
		return 0;
	}

	//תʱ
	int CUtility::TimeToControl(SYSTEMTIME &time, CDateTimeCtrl &control)
	{
		if (!control.SetTime(&time))
		{
			return 1;
		}
		return 0;
	}

	//ʱתַ
	int CUtility::TimeToString(char *str, SYSTEMTIME &time)
	{
		sprintf(str, "%04d%02d%02d%02d%02d%02d", time.wYear,time.wMonth, time.wDay, time.wHour, time.wMinute, time.wSecond);
		return 0;
	}

	//ʱתַ
	int CUtility::TimeToString(CString *str, SYSTEMTIME &time)
	{
		str->Format("%04d%02d%02d%02d%02d%02d", time.wYear,time.wMonth, time.wDay, time.wHour, time.wMinute, time.wSecond);
		return 0;
	}

	//ʱתʱṹ
	int CUtility::TimeToTimeInfo(TimeInfo &timeinfo, SYSTEMTIME &time)
	{
		timeinfo.wYear = time.wYear;
		timeinfo.wMonth = time.wMonth;
		timeinfo.wDay = time.wDay;
		timeinfo.wHour = time.wHour;
		timeinfo.wMinute = time.wMinute;
		timeinfo.wSecond = time.wSecond;
		return 0;
	}

	//ʱṹתʱ
	int CUtility::TimeFormTimeInfo(SYSTEMTIME &timeinfo, TimeInfo &time)
	{
		timeinfo.wYear = time.wYear;
		timeinfo.wMonth = time.wMonth;
		timeinfo.wDay = time.wDay;
		timeinfo.wHour = time.wHour;
		timeinfo.wMinute = time.wMinute;
		timeinfo.wSecond = time.wSecond;
		return 0;
	}

	//ʱṹתַ
	int CUtility::TimeInfoToString(TimeInfo &timeinfo, CString &time)
	{
		time.Format("%04d%02d%02d%02d%02d%02d", timeinfo.wYear,timeinfo.wMonth, timeinfo.wDay, timeinfo.wHour, timeinfo.wMinute, timeinfo.wSecond);
		return 0;
	}

}