﻿#ifndef AIFACEPCH_H
#define AIFACEPCH_H

#include "httpmanager/httpmanagerpch.h"

#include <QObject>
#include <QMessageBox>

//通用宏，函数，结构体定义头文件

//#ifdef QT_DEBUG
#include <QDebug>
//#endif

extern qreal xRatio;
extern qreal yRatio;

//分辨率自适应宏
#define adaptx(x) ((x)*xRatio)
#define adapty(y) ((y)*yRatio)
#define adaptxy(x,y) ((x)*xRatio),((y)*yRatio)
#define adaptxywh(x,y,w,h) ((x)*xRatio),((y)*yRatio),((w)*xRatio),((h)*yRatio)

void message_output(const QString &message);

//万分比转换分辨率
qreal rateToResolution(const qreal &streamResolution,const qreal &rate);
//分辨率转换万分比
qreal resolutionToRate(const qreal &streamResolution,const qreal &resolution);

//#ifdef QT_DEBUG
#define check_ercode(x,content)		\
if(0 != (x))	\
{	\
	qDebug()<<"Error Occured! Ercode:"<<x<<content<<__FILE__<<__FUNCTION__<<__LINE__;		\
	message_output(content);		\
	return x;	\
}
//#else
//#define check_ercode(x,content)
//#endif

#define check_ercode_message(x,content)		\
if(0 != (x))	\
{	\
	qDebug()<<"Error Occured! Ercode:"<<x<<content<<__FILE__<<__FUNCTION__<<__LINE__;		\
	return x;	\
}

//#ifdef QT_DEBUG
#define check_ercode_no_return(x,content)		\
if(0 != (x))	\
{	\
	qDebug()<<"Error Occured! Ercode:"<<x<<content<<__FILE__<<__FUNCTION__<<__LINE__;	\
	message_output(content);		\
	return;	\
}
//#else
//#define check_ercode_no_return(x,content)
//#endif

//#ifdef QT_DEBUG
#define error_output(content)		\
{	\
	qDebug()<<"Error Occured!"<<content<<__FILE__<<__FUNCTION__<<__LINE__;	\
	message_output(content);	\
}
//#else
//#define error_output(x)
//#endif

#define check_bool(ercode,content)	\
{	\
	if(false == ercode)	\
	{	\
		qDebug()<<"Ercode: "<<ercode <<content<<__FILE__<<__FUNCTION__<<__LINE__;	\
		message_output(content);		\
		return !ercode;	\
	}	\
}

#define check_bool_no_return(ercode,content)	\
{	\
	if(false == ercode)	\
	{	\
		qDebug()<<"Ercode: "<<ercode <<content<<__FILE__<<__FUNCTION__<<__LINE__;	\
		message_output(content);	\
		return;	\
	}	\
}

#define check_pointer_no_return(x)	\
if(nullptr == x)	\
{	\
	message_output("alloc memory failed!");		\
	return;		\
}

#define check_pointer(x,r)	\
if(nullptr == x)	\
{	\
	message_output("alloc memory failed!");		\
	return r;		\
}

void http_message_output(const int &ercode,const QString &message);

#define check_http_ercode_no_return(x,content)		\
if(0 != x)	\
{	\
	http_message_output(x,content);	\
	return;	\
}	\

class FunctionLock
{
public:
	FunctionLock(bool &flag):m_flag(flag)
	{
		m_flag = false;
	}
	~FunctionLock()
	{
		m_flag = true;
	}

private:
	bool &m_flag;
};

#define func_lock		\
static bool isFinish{true};	\
if(false == isFinish)	\
	return;		\
FunctionLock funcLock(isFinish);

#define warning_box(x)	\
QMessageBox::StandardButton reply = QMessageBox::warning(this, "Warning",\
								x,	\
								QMessageBox::Yes | QMessageBox::No);	\
if (reply == QMessageBox::Yes);	\
else if (reply == QMessageBox::No)		\
	return;

//#define UniqueID_Support

#endif // AIFACEPCH_H
