﻿#ifndef FACELIBRARY_H
#define FACELIBRARY_H

#include <QWidget>

#include "src/inc/aifaceobject.h"

QT_BEGIN_NAMESPACE
class QTableWidget;
QT_END_NAMESPACE

class FaceLibrary : public QWidget
{
	Q_OBJECT
public:
	explicit FaceLibrary(QWidget *parent = nullptr);
	~FaceLibrary();

	/**
	 * @brief init					初始化
	 * @param mac			[in]设备mac地址
	 * @param ip				[in]设备IP地址
	 * @param username	[in]用户名
	 * @param password	[in]密码
	 */
	void init(const QString &mac,const QString &ip,const QString &username,const QString &password);

	/**
	 * @brief initGui		//创建主要控件
	 */
	void initGui();

	/**
	 * @brief initFaceLibraryInfo		初始化脸库信息
	 */
	void updateFaceLibraryInfo();

private:
	QTableWidget *m_faceLibraryTable{nullptr};

	QString m_ip;
	QString m_username;
	QString m_password;

	int m_userID{-1};

	FaceLibraryList m_allFaceLibrary;

signals:

public slots:
	void slot_manage();
	void slot_remove();
	void slot_edit();
	void slot_add();
	void slot_export();
	void slot_import();
	void slot_removeAll();
};

#endif // FACELIBRARY_H
