﻿#ifndef FACERECOGNIZEWIDGET_H
#define FACERECOGNIZEWIDGET_H

#include <QWidget>

#include "src/inc/aifaceobject.h"

QT_BEGIN_NAMESPACE
class QComboBox;
class QLineEdit;
class QTableWidget;
class QCheckBox;
class RecordPlanWidget;
QT_END_NAMESPACE

class FaceRecognizeWidget : public QWidget
{
	Q_OBJECT
public:
	explicit FaceRecognizeWidget(QWidget *parent = nullptr);

	/**
	 * @brief init					初始化
	 * @param mac			[in]设备mac地址
	 * @param ip				[in]设备IP地址
	 * @param username	[in]用户名
	 * @param password	[in]密码
	 */
	void initUserInfo(const QString &mac,const QString &ip,const QString &username,const QString &password);

private:
	/**
	 * @brief initGui		创建界面
	 */
	void initGui();

	/**
	 * @brief updateFaceRecoRule		更新识别规则
	 */
	void updateFaceRecoRule(const int &index = 0);

private:
	QComboBox *m_ruleBox{nullptr};
	QComboBox *m_isEnableBox{nullptr};
	QComboBox *m_identificationRuleBox{nullptr};
	QComboBox *m_compareUpLimitBox{nullptr};
	QLineEdit *m_identificationThresholdEdit{nullptr};
	QTableWidget *m_faceLibraryTable{nullptr};
	QCheckBox *m_alarm1{nullptr};
	QCheckBox *m_alarm2{nullptr};
	QComboBox *m_alarmPlanBox{nullptr};
	RecordPlanWidget *m_recordPlanWidget{nullptr};

	QString m_ip;
	QString m_username;
	QString m_password;

	QVector<RecoRuleFaceLibraryNode> m_faceLibraryNodes;

signals:

public slots:
	void slot_save();
};

#endif // FACERECOGNIZEWIDGET_H
