﻿#ifndef RECORDPLANWIDGET_H
#define RECORDPLANWIDGET_H

#include <QObject>
#include <QWidget>
#include <QPair>

class RecordPlanWidget : public QWidget
{
	Q_OBJECT
public:
	explicit RecordPlanWidget(QWidget *parent = nullptr);

	/**
	 * @brief setEditEnable		设置可否编辑
	 * @param flag					[in]可否编辑
	 */
	void setEditEnable(const bool &flag);

	/**
	 * @brief setRowItems		设置Y轴项目
	 * @param rowItems			[in]Y轴项目
	 */
	void setRowItems(const QVector<QString> &rowItems);

	/**
	 * @brief setColumeItems		设置X轴项目
	 * @param columeItems		[in]X轴项目
	 */
	void setColumeItems(const QVector<QString> &columeItems);

	/**
	 * @brief update		更新界面
	 */
	void updateItems();

	/**
	 * @brief setItemStatus
	 * @param itemStatus
	 */
	void setItemStatus(const QVector<QString> &itemStatus);

	/**
	 * @brief getItemStatus
	 * @param itemStatus
	 */
	void getItemStatus(QVector<QString> &itemStatus);

protected:
	void mousePressEvent(QMouseEvent *event) override;
	void mouseMoveEvent(QMouseEvent *event) override;
	void mouseReleaseEvent(QMouseEvent *event) override;

	void paintEvent(QPaintEvent *event) override;

private:
	QVector<QString> m_rowItems;
	QVector<QString> m_columeItems;

	QVector<QVector<QPair<QRect,bool>>> m_timeBlockItems;

	int m_blockSize{0};

	bool m_currentBlockStatus{false};
	bool m_isAllowEdit{true};
	QPoint m_pressPos;

signals:

public slots:
};

#endif // RECORDPLANWIDGET_H
