﻿#ifndef FACERECOGNIZEPACKAGE_H
#define FACERECOGNIZEPACKAGE_H

#include "src/inc/aifaceobject.h"
#include "src/inc/httpmanager/httpmanagerpch.h"

class FaceRecognizePackage
{
public:
	static FaceRecognizePackage *GetInstance()
	{
		static FaceRecognizePackage faceRecognizePackage;
		return &faceRecognizePackage;
	}

protected:
	FaceRecognizePackage();

public:
	/**
	 * @brief getRecoRuleList			得到识别规则列表
	 * @param ip							[in]IP地址
	 * @param username				[in]用户名
	 * @param password				[in]密码
	 * @param recoRuleList			[out]识别规则列表
	 * @return
	 */
	HttpManagerErcode getRecoRuleList(const QString &ip,const QString &username,const QString &password,RecoRuleList &recoRuleList);

	/**
	 * @brief setRecoRuleList			设置识别规则列表
	 * @param ip							[in]IP地址
	 * @param username				[in]用户名
	 * @param password				[in]密码
	 * @param recoRuleList			[in]识别规则列表
	 * @return
	 */
	HttpManagerErcode setRecoRuleList(const QString &ip,const QString &username,const QString &password,const RecoRuleList &recoRuleList);

private:
	/**
	 * @brief setHeader		设置HTTP请求头
	 * @param ip					[in]IP地址
	 * @param username		[in]用户名
	 * @param password		[in]密码
	 */
	void setHeader(const QString &ip,const QString &username,const QString &password);
};

#endif // FACERECOGNIZEPACKAGE_H
