#ifndef RESTOBJECT_H
#define RESTOBJECT_H

#include <QString>

using RequestType = enum RequestType
{
	RequestType_Unknown,

	RequestType_Get,
	RequestType_Put,
	RequestType_Post,
};

using XmlErcode = enum XmlErcode
{
	XmlErcode_None,

	XmlErcode_ParamError,
};

using XmlNodeType = enum XmlNodeType
{
	XmlNodeType_Unknown,

	XmlNodeType_Root,
	XmlNodeType_Parent,
	XmlNodeType_Child,
};

using KeyNode = struct KeyNode
{
	KeyNode()=default;
	KeyNode(QString k,int c = -1):
		key(k),
		channel(c)
	{}

	bool operator<(const KeyNode &node) const
	{
		if(this->key<node.key)
			return true;
		else if(this->key==node.key)
		{
			if(this->key<node.key)
				return true;
			else
				return false;
		}
		else
			return false;
	}

	QString key;
	int channel{-1};
};
using KeyNodeList = QVector<KeyNode>;

#endif // RESTOBJECT_H
