﻿#ifndef XMLREADER_H
#define XMLREADER_H

#include "src/inc/restclient/restobject.h"

#include <QMap>
#include <QString>
#include <QDomDocument>

class XmlReader
{
public:
	XmlReader();

	/**
	 * @brief setContent		xml文件内容
	 * @param xml				[in]xml文件内容
	 */
	bool setContent(const QString &xml);

	/**
	 * @brief readNodeValue		读取某个节点的值
	 * @param key						[in]节点名称，如果节点是多级则使用该格式"name-name-name"
	 * @param value					[out]节点值
	 */
	XmlErcode readNodeValue(const QVector<KeyNode> &keys,QString &value);

private:
	QDomDocument m_domDocument;

//	using ElementNode = struct ElementNode
//	{
//		XmlNodeType nodeType;
//		QString nodeName;
//		QString nodeValue;
//		QDomNode node;

//		QMap<QString,ElementNode *> childNodes;
//	};
//	ElementNode *m_node{nullptr};
};

#endif // XMLREADER_H
