﻿#ifndef XMLANALYSISER_H
#define XMLANALYSISER_H

#include "src/inc/restclient/restobject.h"

#include <QDomDocument>
#include <QMap>

class XmlWritter
{
public:
	XmlWritter();

	/**
	 * @brief addHead			写入XML头部
	 * @param headName		[in]名称
	 * @return
	 */
	bool addHead(const QString &headName);

	/**
	 * @brief addNode					添加一个XML节点
	 * @param nodeType				[in]节点类型
	 * @param key							[in]节点名称，如果有多级则使用此种格式"name-name-name"
	 * @param value						[in]值，如果是父节点，不需要值
	 * @param parentNodeName	[in]父节点名称，为空的时候，代表根节点
	 * @return
	 */
	bool addNode(const XmlNodeType &nodeType,const KeyNode &key,const KeyNode &parentNodeName={"",0},const QString &value="");

	/**
	 * @brief exportXml			导出XML字符串
	 * @param xml					[out]xml内容
	 * @return
	 */
	bool exportXml(QByteArray &xml);

private:
	QDomDocument m_domDocument;

	QMap<KeyNode,QDomNode> m_nodes;
};

#endif // XMLANALYSISER_H
