﻿#include "src/inc/aifacepch.h"

qreal xRatio = 0;
qreal yRatio = 0;

#include <QMessageBox>

void message_output(const QString &message)
{
	QMessageBox msgBox;
	msgBox.setText(message);
	msgBox.exec();
}

qreal rateToResolution(const qreal &streamResolution, const qreal &rate)
{
	return streamResolution*(rate/10000.0);
}

qreal resolutionToRate(const qreal &streamResolution, const qreal &resolution)
{
	return resolution/streamResolution*10000.0;
}

void http_message_output(const int &ercode,const QString &message)
{
	QString content;
	switch(static_cast<HttpManagerErcode>(ercode))
	{
	case HttpErcode_AuthFailed:
		content = "Username or password is not correct!";
		break;
	case HttpErcode_Less1Failed:
		content = "Xml and url may not suit!";
		break;
	case HttpErcode_Less2Failed:
		content = "Xml may lack field!";
		break;
	case HttpErcode_Less3Failed:
		content = "Operation not support!";
		break;
	case HttpErcode_Less4Failed:
		content = "Decode failed!";
		break;
	case HttpErcode_Less5Failed:
		content = "Parameter error!";
		break;
	case HttpErcode_Less6Failed:
		content = "Busy when query log!";
		break;
	case HttpErcode_Less7Failed:
		content = "Query log failed!";
		break;
	case HttpErcode_Less8Failed:
		content = "Call sdk failed!";
		break;
	case HttpErcode_Less9Failed:
		content = "Memory leak!";
		break;
	case HttpErcode_Less10Failed:
		content = "Url error!";
		break;
	case HttpErcode_Less11Failed:
		content = "User too more";
		break;
	case HttpErcode_Less12Failed:
		content = "Operation not effective";
		break;
	case HttpErcode_Less13Failed:
		content = "User already exist!";
		break;
	case HttpErcode_ImageFormatError:
		content = "Image format not correct!";
		break;
	case HttpErcode_FaceNotFound:
		content = "There is no face in picture";
		break;
	case HttpErcode_MultiFaceInImage:
		content = "There are more than one face in picture";
		break;
	case HttpErcode_FacePropertyIllegal:
		content = "Face property illegal!";
		break;
	case HttpErcode_FaceRecognizeAlgorithmNotInit:
		content = "Face regocnize algorithm not init";
		break;
	case HttpErcode_CreateFaceGroupFailed:
		content = "Create face group failed!";
		break;
	case HttpErcode_AlgorithmFeatureNotSuit:
		content = "Algorithm feature not suit!";
		break;
	case HttpErcode_FaceGroupNotExist:
		content = "Face group not exist!";
		break;
	case HttpErcode_FaceGroupNumArriveUplimitByKS:
		content = "Face group num arrive up limit!";
		break;
	case HttpErcode_FaceTooBig:
		content = "Face is too big!";
		break;
	case HttpErcode_FaceTooDim:
		content = "Face is too dim!";
		break;
	case HttpErcode_FaceAngleWrong:
		content = "Face angle wrong!";
		break;
	case HttpErcode_FaceTooSmall:
		content = "Face is too small!";
		break;
	case HttpErcode_FaceDetectFailed:
		content = "Face detect failed!";
		break;
	case HttpErcode_FaceImageAlreadyExist:
		content = "Face image already exist!";
		break;
	case HttpErcode_FaceGroupNameAlreadyExist:
		content = "Face group name already exist!";
		break;
	case HttpErcode_PeopleNameAlreadyExist:
		content = "People name already exist!";
		break;
	case HttpErcode_FaceGroupNumArriveUplimit:
		content = "Face group num arrive uplimit!";
		break;
	case HttpErcode_PeopleNumArriveUplimit:
		content = "People num arrive uplimit!";
		break;
	case HttpErcode_CannotAnalysisResponse:
		content = "Can not analysis http response!";
		break;
	case HttpErcode_OtherFailed:
		content = message;
		break;
	default:
		break;
	}

	QMessageBox msgBox;
	msgBox.setText(content);
	msgBox.exec();
}
