﻿#include "src/inc/gui/facelibrary/namewidget.h"

#include "src/inc/aifacepch.h"

#include <QLabel>
#include <QLineEdit>
#include <QPushButton>

NameWidget::NameWidget(QWidget *parent) : QDialog(parent)
{
	this->setGeometry(adaptxywh(100+1300/2-150,100+700/2-50,300,100));
//	this->setAttribute(Qt::WA_DeleteOnClose);
	this->setModal(true);

	initGui();
}

void NameWidget::addExistFaceLibraryName(const QString &name)
{
	m_allFaceLibraryNames.append(name);
}

void NameWidget::initGui()
{
	QFont font("Microsoft YaHei",adaptx(10));

	QLabel *nameEditLabel{nullptr};
	nameEditLabel = new QLabel(this);
	check_pointer_no_return(nameEditLabel);
	nameEditLabel->setFont(font);
	nameEditLabel->setGeometry(adaptxywh(10,10,100,30));
	nameEditLabel->setText("Library Name");
	nameEditLabel->show();

	QLineEdit *nameEdit{nullptr};
	nameEdit = new QLineEdit(this);
	check_pointer_no_return(nameEdit)
	nameEdit->setFont(font);
	nameEdit->setGeometry(adaptxywh(110,10,180,30));
	nameEdit->show();

	QPushButton *save{nullptr};
	save = new QPushButton(this);
	check_pointer_no_return(save);
	save->setGeometry(adaptxywh(150-40,50,80,30));
	save->setFont(font);
	save->setText("Save");
	connect(save,&QPushButton::released,[this,nameEdit]()
	{
		func_lock

		if(true==nameEdit->text().isEmpty())
		{
			message_output("Name is Empty!");
			return;
		}

		if(m_allFaceLibraryNames.contains(nameEdit->text()))
		{
			message_output("Name already exist!");
			return;
		}

		emit signal_name(nameEdit->text());
		this->close();
	});
}
