﻿#include "src/inc/gui/facelibrary/personitemaddwidget.h"

#include <QString>
#include <QLineEdit>
#include <QDateTimeEdit>
#include <QComboBox>

#include "src/inc/aifacepch.h"
#include "src/inc/httpmanager/facelibrarypackage.h"

PersonItemAddWidget::PersonItemAddWidget()
{

}

void PersonItemAddWidget::setLibraryID(const QString &libraryID)
{
	m_libraryID = libraryID;
}

void PersonItemAddWidget::slot_save()
{
	func_lock

	HttpManagerErcode ercode{HttpErcode_None};

	m_itemInfo.name=m_nameEdit->text();
	m_itemInfo.sex=m_sexBox->currentText();
	m_itemInfo.certificateType=m_certificateTypeBox->currentText();
	m_itemInfo.certificateID=m_certificateIDEdit->text();
	m_itemInfo.country=m_countryEdit->text();
	m_itemInfo.address=m_provinceEdit->text()+"#"+m_cityEdit->text();

	QString birthday=m_birthdayEdit->text().replace("-","");
	m_itemInfo.birthday=birthday;
	m_itemInfo.libraryID=m_libraryID;

	QString personID, uniqueID;
	ercode = FaceLibraryPackage::GetInstance()->addPersonInfo(m_ip,m_username,m_password,m_itemInfo,m_faceImage,personID,uniqueID);
	if(static_cast<HttpManagerErcode>(4111) == ercode)
	{
#ifdef UniqueID_Support
		QString message = "UniqueID: "+uniqueID;
#else
		QString message = "PersonID: "+personID;
#endif
		message_output(message);
	}
	check_http_ercode_no_return(ercode,"Add person info failed!")

	message_output("Add person info successfully");

	emit signal_updateFaceLibrary();
}
