#ifndef RECORDDETAIL_H
#define RECORDDETAIL_H

#include <QWidget>

QT_BEGIN_NAMESPACE
class QLabel;
QT_END_NAMESPACE

class RecordDetail : public QWidget
{
	Q_OBJECT
public:
	explicit RecordDetail(QWidget *parent = nullptr);

	/**
	 * @brief init					初始化
	 * @param mac			[in]设备mac地址
	 * @param ip				[in]设备IP地址
	 * @param username	[in]用户名
	 * @param password	[in]密码
	 */
	void initUserInfo(const QString &mac,const QString &ip,const QString &username,const QString &password);

	/**
	 * @brief updateRecordDetail		更新记录详细信息
	 * @param logID							[in]记录ID
	 * @param faceLibraryName			[in]脸库名称
	 * @param similar							[in]相似度
	 * @param recognizeTime				[in]识别时间
	 * @param snapshotPath				[in]抓拍图片路径
	 */
	void updateRecordDetail(const QString &logID,const QString &faceLibraryName,const QString &similar,const QString &recognizeTime,const QString &snapshotPath);

private:
	QString m_ip;
	QString m_username;
	QString m_password;

	QLabel *m_captureImage{nullptr};
	//对比图
	QLabel *m_compareImage{nullptr};
	//人脸库
	QLabel *m_faceLibraryName{nullptr};
	//相似度
	QLabel *m_similar{nullptr};
	//姓名
	QLabel *m_name{nullptr};
	//生日
	QLabel *m_birthday{nullptr};
	//性别
	QLabel *m_sex{nullptr};
	//证件类型
	QLabel *m_certificateType{nullptr};
	//证件ID
	QLabel *m_certificateID{nullptr};
	//国家
	QLabel *m_country{nullptr};
	//省份
	QLabel *m_province{nullptr};
	//城市
	QLabel *m_city{nullptr};
	//识别时间
	QLabel *m_recognizeTime{nullptr};

private:
	/**
	 * @brief initGui		创建界面
	 */
	void initGui();

signals:

public slots:
};

#endif // RECORDDETAIL_H
