﻿#ifndef SNAPSHOTITEMWIDGET_H
#define SNAPSHOTITEMWIDGET_H

#include <QWidget>

QT_BEGIN_NAMESPACE
class QLabel;
class QPushButton;
QT_END_NAMESPACE

class SnapShotItemWidget : public QWidget
{
	Q_OBJECT
public:
	explicit SnapShotItemWidget(QWidget *parent = nullptr);

	/**
	 * @brief initGui		创建GUI
	 */
	void initGui();

	/**
	 * @brief init					初始化
	 * @param mac			[in]设备mac地址
	 * @param ip				[in]设备IP地址
	 * @param username	[in]用户名
	 * @param password	[in]密码
	 */
	void init(const QString &mac,const QString &ip,const QString &username,const QString &password);

	/**
	 * @brief setImageData		设置图片数据
	 * @param imageData			[in]图片数据
	 */
	void setImageData(const QByteArray &imageData);

	/**
	 * @brief setImageInfo			设置图片信息
	 * @param imageInfo			[in]图片信息
	 */
	void setImageInfo(const QString &imageInfo);

private:
	QByteArray m_faceImageData;

	QLabel *m_image{nullptr};
	QLabel *m_info{nullptr};
	QPushButton *m_addToFaceLibrary{nullptr};

	QString m_ip;
	QString m_username;
	QString m_password;

protected:
	void enterEvent(QEvent *event) override;
	void leaveEvent(QEvent *event) override;

signals:

public slots:
	void slot_addToFaceLibrary();
};

#endif // SNAPSHOTITEMWIDGET_H
