﻿#include "src/inc/gui/status/statuswidget.h"

#include "src/inc/aifacepch.h"

#include <QLabel>
#include <QPushButton>
#include <QCloseEvent>

StatusWidget::StatusWidget(QWidget *parent) : QDialog(parent)
{
	this->setModal(true);
	this->setWindowFlags(Qt::CustomizeWindowHint | Qt::WindowCloseButtonHint);

	m_message = new QLabel(this);
	m_message->setFont(QFont("Microsoft YaHei",adaptx(10)));
	m_message->show();
//	m_ok = new QPushButton(this);

//	connect(this,&StatusWidget::signal_message,[this](QString text){m_message->setText(text);});
}

void StatusWidget::setMessage(const QString &message)
{
	m_message->setText(message);
//	emit signal_message(message);
}

void StatusWidget::setFinished()
{
	m_isFinished = true;
}

void StatusWidget::resizeEvent(QResizeEvent *event)
{
	m_message->setGeometry(adaptx(10),adapty(10),this->width()-adaptx(20),this->height()-adapty(20));
}

void StatusWidget::closeEvent(QCloseEvent *event)
{
	if(true == m_isFinished)
		event->accept();
	else
		event->ignore();
}
