﻿#ifndef STATUSWIDGET_H
#define STATUSWIDGET_H

#include <QDialog>

QT_BEGIN_NAMESPACE
class QLabel;
class QPushButton;
QT_END_NAMESPACE

class StatusWidget : public QDialog
{
	Q_OBJECT
public:
	explicit StatusWidget(QWidget *parent = nullptr);

	/**
	 * @brief setMessage		设置信息
	 * @param message			[in]信息
	 */
	void setMessage(const QString &message);

	/**
	 * @brief setFinished			任务完成
	 */
	void setFinished();

protected:
	void resizeEvent(QResizeEvent *) override;
	void closeEvent(QCloseEvent *) override;

private:
	QLabel *m_message{nullptr};
//	QPushButton *m_ok{nullptr};

	bool m_isFinished{false};

signals:
	void signal_message(QString);

public slots:
};

#endif // STATUSWIDGET_H
