﻿#include "src/inc/httpmanager/httpmanagerpch.h"
#include "src/inc/restclient/xmlreader.h"

HttpManagerErcode analysisResponseStatusCode(const QByteArray &response)
{	
	XmlReader xmlReader;
	xmlReader.setContent(response);
	QVector<KeyNode> keys{{"ResponseStatus"},{"statusCode",1}};

	QString value;
	xmlReader.readNodeValue(keys,value);

	HttpManagerErcode ercode{HttpErcode_None};
	switch(value.toInt())
	{
	case 0:
		ercode = HttpErcode_None;
		break;
	case -1:
		ercode = HttpErcode_Less1Failed;
		break;
	case -2:
		ercode = HttpErcode_Less2Failed;
		break;
	case -3:
		ercode = HttpErcode_Less3Failed;
		break;
	case -4:
		ercode = HttpErcode_Less4Failed;
		break;
	case -5:
		ercode = HttpErcode_Less5Failed;
		break;
	case -6:
		ercode = HttpErcode_Less6Failed;
		break;
	case -7:
		ercode = HttpErcode_Less7Failed;
		break;
	case -8:
		ercode = HttpErcode_Less8Failed;
		break;
	case -9:
		ercode = HttpErcode_Less9Failed;
		break;
	case -10:
		ercode = HttpErcode_Less10Failed;
		break;
	case -11:
		ercode = HttpErcode_Less11Failed;
		break;
	case -12:
		ercode = HttpErcode_Less12Failed;
		break;
	case -13:
		ercode = HttpErcode_Less13Failed;
		break;
	case 0x1001:
		ercode = HttpErcode_ImageFormatError;
		break;
	case 0x1002:
		ercode = HttpErcode_FaceNotFound;
		break;
	case 0x1003:
		ercode = HttpErcode_MultiFaceInImage;
		break;
	case 0x1004:
		ercode = HttpErcode_FacePropertyIllegal;
		break;
	case 0x1005:
		ercode = HttpErcode_FaceRecognizeAlgorithmNotInit;
		break;
	case 0x1006:
		ercode = HttpErcode_CreateFaceGroupFailed;
		break;
	case 0x1007:
		ercode = HttpErcode_AlgorithmFeatureNotSuit;
		break;
	case 0x1008:
		ercode = HttpErcode_FaceGroupNotExist;
		break;
	case 0x1009:
		ercode = HttpErcode_FaceGroupNumArriveUplimitByKS;
		break;
	case 0x100a:
		ercode = HttpErcode_FaceTooBig;
		break;
	case 0x100b:
		ercode = HttpErcode_FaceTooDim;
		break;
	case 0x100c:
		ercode = HttpErcode_FaceAngleWrong;
		break;
	case 0x100d:
		ercode = HttpErcode_FaceTooSmall;
		break;
	case 0x100e:
		ercode = HttpErcode_FaceNotFound;
		break;
	case 0x100f:
		ercode = HttpErcode_FaceImageAlreadyExist;
		break;
	case 0x1064:
		ercode = HttpErcode_FaceGroupNameAlreadyExist;
		break;
	case 0x1065:
		ercode = HttpErcode_PeopleNameAlreadyExist;
		break;
	case 0x1066:
		ercode = HttpErcode_FaceGroupNumArriveUplimit;
		break;
	case 0x1067:
		ercode = HttpErcode_PeopleNumArriveUplimit;
		break;
	default:
		ercode = HttpErcode_OtherFailed;
		break;
	}

	return ercode;
}
