﻿#include "src/inc/restclient/xmlreader.h"

#include <QStringList>
#include <QDebug>

XmlReader::XmlReader()
{
}

bool XmlReader::setContent(const QString &xml)
{
	bool flag{false};

	//设置根节点内容
	flag=m_domDocument.setContent(xml);

	return flag;
}

XmlErcode XmlReader::readNodeValue(const QVector<KeyNode> &keys, QString &value)
{
	//分割字段名
	if(true==keys.empty())
		return XmlErcode_ParamError;

	//如果第一个字段名不等于根节点名称
	QDomElement root = m_domDocument.documentElement();
	if(root.nodeName()!=keys[0].key)
		return XmlErcode_ParamError;

	QDomNode domNode = root;
	QVector<KeyNode>::const_iterator iter;
	for(iter=keys.begin()+1;iter!=keys.end();++iter)
	{
		//当前XML节点下的所有孩子节点
		QDomNodeList domList = domNode.childNodes();
		bool isFind{false};
		for(int i=0;i<domList.length();++i)
		{
			QDomNode node=domList.at(i);

			//到达一个节点
			if(node.nodeName()==iter->key)
			{
				if(-1 == iter->channel)
				{
					domNode=node;
					isFind=true;
					break;
				}
				else if(i == iter->channel)
				{
					domNode=node;
					isFind=true;
					break;
				}
			}
		}

		if(false==isFind)
			return XmlErcode_ParamError;

		if(iter+1==keys.end())
			break;
	}

	value=domNode.toElement().text();

	return XmlErcode_None;
}
