﻿#include "src/inc/restclient/xmlwritter.h"

#include "src/inc/aifacepch.h"

#include <QDomProcessingInstruction>

XmlWritter::XmlWritter()
{

}

bool XmlWritter::addHead(const QString &headName)
{
	//写入XML头部
	QDomProcessingInstruction instruction;
	m_domDocument.createProcessingInstruction(headName,"version=\"1.0\" encoding=\"UTF-8\"");

	m_domDocument.appendChild(instruction);

	return true;
}

bool XmlWritter::addNode(const XmlNodeType &nodeType,const KeyNode &key, const KeyNode &parentNode, const QString &value)
{
	QDomElement element=m_domDocument.createElement(key.key);

	switch(nodeType)
	{
	case XmlNodeType_Root:
	{
		m_domDocument.appendChild(element);
		m_nodes[key]=element;
	}
		break;
	case XmlNodeType_Parent:
		//如果没找到节点
		if(false==m_nodes.contains(parentNode))
		{
			error_output("Node "+key.key+" not found!")
			return false;
		}

		m_nodes[parentNode].appendChild(element);
		m_nodes[key]=element;
		break;
	case XmlNodeType_Child:
	{
		//如果没找到节点
		if(false==m_nodes.contains(parentNode))
		{
			error_output("Node "+key.key+" not found!")
			return false;
		}

		QDomText textNode=m_domDocument.createTextNode(value);
		element.appendChild(textNode);
		m_nodes[parentNode].appendChild(element);
	}
		break;
	default:
		break;
	}

	return true;
}

bool XmlWritter::exportXml(QByteArray &xml)
{
	xml=m_domDocument.toByteArray();

	return true;
}
