#ifndef DEVICE_MANAGER_H

#define DEVICE_MANAGER_H

#include "./VideoNetClientDemo_Common.h"
#include "./UserManager.h"

namespace structure
{

	class DeviceInformation
	{
	public:
		DeviceInformation(){}
		~DeviceInformation(){}
		DeviceInformation(const DeviceInformation &obj);
		DeviceInformation& operator=(const DeviceInformation &obj);
		bool operator==(const DeviceInformation &obj);
	public:
		DWORD	m_Command;
		string	m_cDevice;
	};

	//˶󲻿ɿ,ʹʱע
	class DeviceInfoManager
	{
	public:
		DeviceInfoManager(){}
		~DeviceInfoManager(){}
		DeviceInfoManager(const DeviceInfoManager &obj);
		DeviceInfoManager& operator=(const DeviceInfoManager &obj);
		bool operator==(const DeviceInfoManager &obj);
	public:
		DeviceInformation	m_cDeviceInformation;
		UserManager	m_cUserManager;
		typedef list<HUSER>	ListUserHandle;
		ListUserHandle	m_lsUserHandle;
	};

	struct IDeviceManagerVisitor
	{
		virtual int DeviceManagerVisit(int id, const DeviceInformation &device);
	};

	//豸
	class DeviceManager
	{
	public:
		DeviceManager();
		~DeviceManager();
	public:
		int Insert(int &id);
		int Remove(int &id);
		int Search(int &id);
		int Insert(int id, HUSER user);
		int Remove(int id, HUSER user);
		int Search(int &id, HUSER user);
		int SetDeviceInfo(int id, DeviceInformation &device);
		int GetDeviceInfo(int id, DeviceInformation &device);
		int GetUser(int id, UserManager **user);
		int Visit(IDeviceManagerVisitor	*pVisitor);
	protected:
		DISABLE_COPY_CAPABILITY_OBJECT(DeviceManager);
	protected:
		int CreateID(int &id);
		int BuildID(int &id);
	private:
		//˶󲻿ɿ,ʹʱע
		typedef pair<int, DeviceInfoManager>	PairDevice;
		typedef list<PairDevice>	ListDeviceManager;
		ListDeviceManager	m_lsDeviceManager;
	};

}

#endif