#ifndef REAL_STREAM_MANAGER_H

#define REAL_STREAM_MANAGER_H

#include "./VideoNetClientDemo_Common.h"
#include "./OutputToFile.h"
#include "./Thread.h"

namespace structure
{

	class RealStreamInformation
	{
	public:
		RealStreamInformation() : m_FrameSerial(0){}
		~RealStreamInformation(){}
		RealStreamInformation(const RealStreamInformation &obj);
		RealStreamInformation& operator=(const RealStreamInformation &obj);
		bool operator==(const RealStreamInformation &obj);
	public:
		DWORD	m_Channel;
		DWORD	m_Protocol;
		DWORD	m_Stream;
		DWORD	m_FrameSerial;
		string	m_cRecord;
	};

	//˶󲻿ɿ,ʹʱע
	class RealStreamInfoManager
	{
	public:
		RealStreamInfoManager(){}
		~RealStreamInfoManager(){}
		RealStreamInfoManager(const RealStreamInfoManager &obj){(*this) = obj;}
		RealStreamInfoManager& operator=(const RealStreamInfoManager &obj);
		bool operator==(const RealStreamInfoManager &obj);
	public:
		RealStreamInformation	m_StreamInfo;
		common::COutputToFile	m_StreamOutput;
	};

	struct IRealStreamManagerVisitor
	{
		virtual int RealStreamManagerVisitor(HSTREAM id, const RealStreamInfoManager &RealStream);
	};

	//ʵʱ
	class RealStreamManager
	{
	public:
		RealStreamManager();
		~RealStreamManager();
	public:
		int Insert(HSTREAM &id);
		int Remove(HSTREAM &id);
		int Stream(HSTREAM id, char *buffer, int length);
		int GetInfo(HSTREAM id, RealStreamInfoManager **RealStream);
		int Visit(IRealStreamManagerVisitor	*pVisitor);
	protected:
		DISABLE_COPY_CAPABILITY_OBJECT(RealStreamManager);
	private:
		typedef pair<HSTREAM, RealStreamInfoManager>	PairRealStream;
		typedef list<PairRealStream>	ListRealStreamManager;
		ListRealStreamManager	m_lsRealStreamManager;
	};

	//ʵʱת
	class CycleRealStream : public common::IThreadExecute
	{
	public:
		CycleRealStream();
		~CycleRealStream();
	public:
		//
		int Start(DWORD	interval);
		//ֹͣ
		int Stop();
		//Ϣ
		int SetInformation(HUSER user, RealStreamInformation &information);
		//
		int CheckStream(HSTREAM stream);
	public:
		//ִ߳
		int execute();
	protected:
		DISABLE_COPY_CAPABILITY_OBJECT(CycleRealStream);
	private:
		HUSER					m_user;
		HSTREAM					m_stream[MAX_CHANNEL_NUMBER];
		DWORD					m_interval;
		common::CThread			m_thread;
		RealStreamInformation	m_information;
	};

}

#endif