#ifndef UPLOAD_MANAGER_H

#define UPLOAD_MANAGER_H

#include "./VideoNetClientDemo_Common.h"

namespace structure
{

	class UploadInformation
	{
	public:
		UploadInformation(){}
		~UploadInformation(){}
		UploadInformation(const UploadInformation &obj);
		UploadInformation& operator=(const UploadInformation &obj);
		bool operator==(const UploadInformation &obj);
	public:
		string	m_cUploadFile;
	};

	struct IUploadManagerVisitor
	{
		virtual int UploadManagerVisitor(HFILE_TRANSFER id, const UploadInformation &info);
	};

	//ϴ
	class UploadManager
	{
	public:
		UploadManager();
		~UploadManager();
	public:
		int Insert(HFILE_TRANSFER &id);
		int Remove(HFILE_TRANSFER &id);
		int GetInfo(HFILE_TRANSFER id, UploadInformation **info);
		int Visit(IUploadManagerVisitor	*pVisitor);
	protected:
		DISABLE_COPY_CAPABILITY_OBJECT(UploadManager);
	private:
		typedef pair<HFILE_TRANSFER, UploadInformation>	PairElement;
		typedef list<PairElement>	ListManager;
		ListManager	m_lsManager;
	};

}

#endif