#ifndef USER_MANAGER_H

#define USER_MANAGER_H

#include "./VideoNetClientDemo_Common.h"
#include "./RealStreamManager.h"
#include "./TalkStreamManager.h"
#include "./HistoryQueryManager.h"
#include "./HistoryStreamManager.h"
#include "./TransparentManager.h"
#include "./DownloadManager.h"
#include "./UploadManager.h"

namespace structure
{

	class UserInformation
	{
	public:
		UserInformation(){}
		~UserInformation(){}
		UserInformation(const UserInformation &obj);
		UserInformation& operator=(const UserInformation &obj);
		bool operator==(const UserInformation &obj);
	public:
		string	m_cUserName;
		string	m_cPassWord;
	};

	class UserEventInformation
	{
	public:
		UserEventInformation();
		~UserEventInformation(){}
		UserEventInformation(const UserEventInformation &obj);
		UserEventInformation& operator=(const UserEventInformation &obj);
		bool operator==(const UserEventInformation &obj);
	public:
		bool	m_EventSubscribe[MAX_USER_EVENT_NUMBER];
	};

	//˶󲻿ɿ,ʹʱע
	class UserInfoManager
	{
	public:
		UserInfoManager(){}
		~UserInfoManager(){}
		UserInfoManager(const UserInfoManager &obj);
		UserInfoManager& operator=(const UserInfoManager &obj);
		bool operator==(const UserInfoManager &obj);
	public:
		RealStreamManager		m_cRealStreamManager;
		TalkStreamManager		m_cTalkStreamManager;
		HistoryQueryManager		m_cHistoryQueryManager;
		HistoryStreamManager	m_cHistoryStreamManager;
		TransparentManager		m_cTransparentManager;
		DownloadManager			m_cDownloadManager;
		UploadManager			m_cUploadManager;
	public:
		UserInformation			m_cUserInformation;
		UserEventInformation	m_cUserEventInformation;
	};

	struct IUserManagerVisitor
	{
		virtual int UserManagerVisitor(HUSER id, const UserInfoManager &user);
	};

	//û
	class UserManager
	{
	public:
		UserManager();
		~UserManager();
	public:
		int Insert(HUSER &id);
		int Remove(HUSER &id);
		int SetDevice(string strDevice);
		int GetDevice(string &strDevice);
		int GetUserInfo(HUSER &id, UserInfoManager **info);
		int GetRealStream(HUSER &id, RealStreamManager **stream);
		int GetTalkStream(HUSER &id, TalkStreamManager **stream);
		int GetHistoryQuery(HUSER &id, HistoryQueryManager **stream);
		int GetHistoryStream(HUSER &id, HistoryStreamManager **stream);
		int GetTransparent(HUSER &id, TransparentManager **stream);
		int GetDownload(HUSER &id, DownloadManager **stream);
		int GetUpload(HUSER &id, UploadManager **stream);
		int Visit(IUserManagerVisitor	*pVisitor);
	protected:
		DISABLE_COPY_CAPABILITY_OBJECT(UserManager);
	protected:
		int GetInfo(HUSER &id, UserInfoManager **info);
	private:
		typedef pair<HUSER, UserInfoManager>	PairUser;
		typedef list<PairUser>	ListUserManager;
		ListUserManager	m_lsUserManager;
		string	m_Device;
	};

}

#endif