// VideoNetClientDemoDlg.h : ͷļ
//

#pragma once
#include "afxcmn.h"

#include "./VideoNetClientDemo_Common.h"
#include "./DeviceManager.h"
#include "./OutputToFile.h"
#include "afxwin.h"
using namespace structure;


#define DEVICEREGISTERPORT 6005
#define WM_DEVICEREGISTER WM_USER+1 
// CVideoNetClientDemoDlg Ի
class CVideoNetClientDemoDlg : public CDialog
{
// 
public:
	CVideoNetClientDemoDlg(CWnd* pParent = NULL);	// ׼캯

// Ի
	enum { IDD = IDD_VIDEONETCLIENTDEMO_DIALOG };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV ֧

// ʵ
protected:
	HICON m_hIcon;

	//Ϣ
	int				m_iOutputMessage;
	//豸
	DeviceManager	m_cDeviceManager;
	//ʷƬδСѯ¼
	HANDLE			m_hHistoryQueryEvent;
	//ʷƬδС
	DWORD			m_dwHistoryQuerySize;
	//Ϣ
	common::COutputToFile	m_cOutputToFile;
	//ʵʱת
	list<DeviceRegisterInfo> m_lsDeviceRegistartInfo;
	structure::CycleRealStream	m_cCycleRealStream;
	common::COutputToFile	m_cOutputToFileTrans;

	int InitDialog(void);
	int DeviceRegisterIsRepeat(LPDeviceRegisterInfo pDeviceRegister);
	static int CBF_DeviceRegister(LPDeviceRegisterInfo pDeviceRegister);
	int InitRegisterDevServer(void);
	int Output(const char *format, ...);
	int OutputInformation(CString info);
	int GetSelectDevice(int &id);
	int GetSelectUser(HUSER &user);
	int GetSelectUserManager(UserManager **user);
	int GetSelectUserManager(HUSER &hUser, UserManager **user);
	int GetSelectUserRealStreamManager(HUSER &hUser, RealStreamManager **hStream, string *sDevice = NULL);
	int GetSelectUserTalkStreamManager(HUSER &hUser, TalkStreamManager **hStream, string *sDevice = NULL);
	int GetSelectUserHistoryQueryManager(HUSER &hUser, HistoryQueryManager **hStream, string *sDevice = NULL);
	int GetSelectUserHistoryStreamManager(HUSER &hUser, HistoryStreamManager **hStream, string *sDevice = NULL);
	int GetSelectUserTransparentManager(HUSER &hUser, TransparentManager **hStream, string *sDevice = NULL);
	int GetSelectUserDownloadManager(HUSER &hUser, DownloadManager **hStream, string *sDevice = NULL);
	int GetSelectUserUploadManager(HUSER &hUser, UploadManager **hStream, string *sDevice = NULL);
	int GetListSelectItem(int &count, int &data, CListCtrl *pList);
	int RealStreamConnect(HUSER hUser, string device, RealStreamManager *stream, RealStreamInformation &info, bool start = false);
	int StreamMediaControl(HSTREAM hStream, eTaskControl control);
	int RefreshStreamInfo(int count, HSTREAM stream, RealStreamInformation &info);
	int RefreshStreamInfo(int count, HSTREAM stream, TalkStreamInformation &info);
	int RefreshStreamInfo(int count, HSTREAM stream, HistoryQueryInformation &info);
	int RefreshStreamInfo(int count, HSTREAM stream, HistoryStreamInformation &info);
	int RefreshStreamInfo(int count, HSTREAM stream, TransparentInformation &info);
	int RefreshStreamInfo(int count, HSTREAM stream, DownloadInformation &info);
	int RefreshStreamInfo(int count, HSTREAM stream, UploadInformation &info);
	void ChangeFontInfo(FontPara &lfont, const LOGFONT &rfont);

	int ReceiveUserEvent(HUSER hUser, DWORD eEvent,DWORD dwParam1, DWORD dwParam2, DWORD dwParam3, DWORD dwUserData);
	int ReceiveRealStream(HSTREAM hStream, const StreamMediaFrame cFrame, DWORD dwUserData);
	int ReceiveTalkStream(HSTREAM hStream, eVoiceStreamSource eSource, const StreamVoiceFrame cFrame, DWORD dwUserData);
	int ReceiveHistoryStream(HSTREAM hStream, const StreamMediaFrame cFrame, DWORD dwUserData);
	int ReceiveTransparent(HTRANSPARENT hTransparent, const LPBuffer pBuffer, DWORD dwUserData);

	static int CALLBACK UserEventCallback(HUSER hUser, DWORD eEvent, DWORD dwParam1, DWORD dwParam2, DWORD dwParam3, DWORD dwUserData);
	static int CALLBACK RealStreamCallback(HSTREAM hStream, const StreamMediaFrame *cFrame, DWORD dwUserData);
	static int CALLBACK TalkStreamCallback(HSTREAM hStream, eVoiceStreamSource eSource, const StreamVoiceFrame *cFrame, DWORD dwUserData);
	static int CALLBACK HistoryStreamCallback(HSTREAM hStream, const StreamMediaFrame *cFrame, DWORD dwUserData);
	static int CALLBACK TransparentCallback(HTRANSPARENT hTransparent, const LPBuffer pBuffer, DWORD dwUserData);

	// ɵϢӳ亯
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	DECLARE_MESSAGE_MAP()
public:
	int TransparentSend(HTRANSPARENT h, BYTE *buffer, int length);
	int TalkSend(HSTREAM h, BYTE *buffer, int length);
	int RealStreamConnect(HSTREAM &stream, HUSER hUser, const LPRealStreamPara para);
	int RealStreamDisconnect(HSTREAM stream);
	int LogQueryConnect(HLOG_QUERY *hFileQuery, LPLogQueryFactor pLogQueryFactor);
	int LogQueryNext(HLOG_QUERY hFileQuery, LPLogQueryResult pLogQueryResult);
	int LogQueryDisconnect(HLOG_QUERY hFileQuery);
	int FileQueryConnect(HFILE_QUERY *hFileQuery, LPFileQueryFactor pFileQueryFactor);
	int FileQueryNext(HFILE_QUERY hFileQuery, LPFileQueryResult pFileQueryResult);
	int FileQueryDisconnect(HFILE_QUERY hFileQuery);
	int ForceIFrame(DWORD channel);
	int CaptureImage(DWORD channel, eImageFormat format);
	int ClearAlarm(DWORD channel, DWORD type);
	int RecordControl(DWORD channel, DWORD type);
	int GetRecordState(DWORD channel);
	int AlarmOut(DWORD channel, DWORD type);
    int GetAlarmOutState();
    int GetAlarmInState();
	int PTZControl(DWORD channel, DWORD command, DWORD Para1, DWORD Para2, DWORD Para3, DWORD Para4);
	int Reboot();
	int Shutdown();
    int SetDefense();
    int UnsetDefense();
	int DiskGroupManage();
public:
	afx_msg void OnServiceStart();
	afx_msg void OnServiceStop();
	afx_msg void OnDeviceInsert();
	afx_msg void OnDeviceRemove();
	afx_msg void OnUserLogin();
	afx_msg void OnUserLogout();
	afx_msg void OnUserEvent();
	afx_msg void OnUserConfig();
	afx_msg void OnUserControl();
	afx_msg void OnUserPTZControl();
	afx_msg void OnStringToLattice();
	afx_msg void OnRealStreamConnect();
	afx_msg void OnRealStreamDisconnect();
	afx_msg void OnRealStreamStart();
	afx_msg void OnRealStreamStop();
	afx_msg void OnRealStreamStartCycle();
	afx_msg void OnRealStreamStopCycle();
	afx_msg void OnTalkStreamConnect();
	afx_msg void OnTalkStreamDisconnect();
	afx_msg void OnTalkStreamStart();
	afx_msg void OnTalkStreamStop();
	afx_msg void OnHistoryQueryConnect();
	afx_msg void OnHistoryQueryDisconnect();
	afx_msg void OnHistoryQueryQuery();
	afx_msg void OnHistoryStreamConnect();
	afx_msg void OnHistoryStreamDisconnect();
	afx_msg void OnHistoryStreamStart();
	afx_msg void OnHistoryStreamStop();
	afx_msg void OnHistoryStreamAsync();
	afx_msg void OnTransparentConnect();
	afx_msg void OnTransparentDisconnect();
	afx_msg void OnTransparentSend();
	afx_msg void OnFileQuery();
	afx_msg void OnDownloadConnect();
	afx_msg void OnDownloadDisconnect();
	afx_msg void OnUploadConnect();
	afx_msg void OnUploadDisconnect();
	afx_msg void OnLogQuery();
	afx_msg void OnInformationRecord();
	afx_msg void OnInformationCopy();
	afx_msg void OnInformationSave();
	afx_msg void OnInformationClear();
	afx_msg void OnClose();
	CTreeCtrl m_TRDevice;
	CTreeCtrl m_TRUser;
	CListCtrl m_LSRealStream;
	CListCtrl m_LSHistoryStream;
	CListCtrl m_LSTalkStream;
	CListCtrl m_LSHistoryQuery;
	CListCtrl m_LSTransparent;
	CListCtrl m_LSDownload;
	CListCtrl m_LSUpload;
	CEdit m_EDOutput;
    afx_msg void OnInformationGetfileheader();
	afx_msg LRESULT OnDeviceRegister(WPARAM,LPARAM);
	/*afx_msg void OnPassivityconnectSetconfig();

	afx_msg void OnPassivityconnectGetconfig();
	afx_msg void OnPassivityconnectGetchannelinformation();
	afx_msg void OnPassivityconnectSetdisplayconfig();
	afx_msg void OnPassivityconnectGetdisplayconfig();
	afx_msg void OnStreamtransferConnect();
	afx_msg void OnStreamtransferDisconnect();
	afx_msg void OnStreamtransferSend();
	afx_msg void OnDecodechannelSetconfig();
	afx_msg void OnDecodechannelGetconfig();
	afx_msg void OnDecodechannelSetvideostandard();
	afx_msg void OnDecodechannelGetvideostandard();
	afx_msg void OnDecodechannelGetstatus();
	afx_msg void OnDecodechannelSetplaystatus();
	afx_msg void OnDecodechannelGetplaystatus();
	afx_msg void OnDecodechannelLogoswitch();
	afx_msg void OnDecodechannelDisplaycontrol32844();
	afx_msg void OnDecodechannelLogoupload32846();
	afx_msg void OnTransmitqueryCreate();
	afx_msg void OnTransmitqueryDisconnect();
	afx_msg void OnTransmitqueryQuery();*/
	afx_msg void OnUserGetfrontdevice();
	afx_msg void OnUserSetfrontdevice();
	afx_msg void OnUserGetpreviewlist();
	afx_msg void OnUserSetpreviewlist();
	afx_msg void OnUserFullscreenchannel();
	afx_msg void OnUserReturnfromfullscreen();
	afx_msg void OnUserS();
	afx_msg void OnUserStopcruise();
	afx_msg void OnUserRetrievemonitorcapability();
	afx_msg void OnUserGetmonitorresolution();
	afx_msg void OnUserSetmonitorresolution();
	afx_msg void OnUserSetmotionmorethan32();
	afx_msg void OnUserGetmotionmorethan32();
	afx_msg void OnUserSetdefrog();
	afx_msg void OnUserGetdefrog();
	afx_msg void OnUserSetadvancedchannel();
	afx_msg void OnUserGetadvancedchannel();
};
