
#include "../platform/win32/inc/stdafx.h"
#include "../inc/DeviceManager.h"

namespace structure
{

	DeviceInformation::DeviceInformation(const DeviceInformation &obj)
	{
		(*this) = obj;
	}

	DeviceInformation& DeviceInformation::operator=(const DeviceInformation &obj)
	{
		this->m_cDevice = obj.m_cDevice;
		this->m_Command = obj.m_Command;
		return (*this);
	}
	bool DeviceInformation::operator==(const DeviceInformation &obj)
	{
		if (this->m_cDevice != obj.m_cDevice ||
			this->m_Command != obj.m_Command)
		{
			return false;
		}
		return true;
	}

	DeviceInfoManager::DeviceInfoManager(const DeviceInfoManager &obj)
	{
		(*this) = obj;
	}

	DeviceInfoManager& DeviceInfoManager::operator=(const DeviceInfoManager &obj)
	{
		this->m_cDeviceInformation == obj.m_cDeviceInformation;
		return (*this);
	}

	bool DeviceInfoManager::operator==(const DeviceInfoManager &obj)
	{
		if (this->m_cDeviceInformation == obj.m_cDeviceInformation)
		{
			return true;
		}
		return false;
	}

	//豸
	DeviceManager::DeviceManager()
	{
		m_lsDeviceManager.clear();
	}

	DeviceManager::~DeviceManager()
	{
		m_lsDeviceManager.clear();
	}

	int DeviceManager::Insert(int &id)
	{
		if (CHECK_RET_FAILED(CreateID(id)))
		{
			return 1;
		}
		PairDevice cDevice;
		cDevice.first = id;
		//豸
		m_lsDeviceManager.push_back(cDevice);
		return 0;
	}

	int DeviceManager::Remove(int &id)
	{
		for (ListDeviceManager::iterator iter = m_lsDeviceManager.begin(); iter != m_lsDeviceManager.end();iter++)
		{
			if (id == iter->first)
			{
				m_lsDeviceManager.erase(iter);
				return 0;
			}
		}
		return 1;
	}

	int DeviceManager::Search(int &id)
	{
		for (ListDeviceManager::iterator iter = m_lsDeviceManager.begin(); iter != m_lsDeviceManager.end();iter++)
		{
			if (id == iter->first)
			{
				return 0;
			}
		}
		return 1;
	}

	int DeviceManager::Insert(int id, HUSER user)
	{
		for (ListDeviceManager::iterator iter = m_lsDeviceManager.begin(); iter != m_lsDeviceManager.end();iter++)
		{
			if (id == iter->first)
			{
				iter->second.m_lsUserHandle.push_back(user);
				return 0;
			}
		}
		return 1;
	}

	int DeviceManager::Remove(int id, HUSER user)
	{
		for (ListDeviceManager::iterator iter = m_lsDeviceManager.begin(); iter != m_lsDeviceManager.end();iter++)
		{
			if (id == iter->first)
			{
				iter->second.m_lsUserHandle.remove(user);
				return 0;
			}
		}
		return 1;
	}
	int DeviceManager::Search(int &id, HUSER user)
	{
		for (ListDeviceManager::iterator iter = m_lsDeviceManager.begin(); iter != m_lsDeviceManager.end();iter++)
		{
			for (DeviceInfoManager::ListUserHandle::iterator jIter = iter->second.m_lsUserHandle.begin(); jIter != iter->second.m_lsUserHandle.end(); jIter++)
			{
				if (user == *jIter)
				{
					id = iter->first;
					return 0;
				}
			}
		}
		return 1;
	}

	int DeviceManager::SetDeviceInfo(int id, DeviceInformation &device)
	{
		for (ListDeviceManager::iterator iter = m_lsDeviceManager.begin(); iter != m_lsDeviceManager.end();iter++)
		{
			if (id == iter->first)
			{
				iter->second.m_cDeviceInformation = device;
				iter->second.m_cUserManager.SetDevice(device.m_cDevice);
				return 0;
			}
		}
		return 1;
	}

	int DeviceManager::GetDeviceInfo(int id, DeviceInformation &device)
	{
		for (ListDeviceManager::iterator iter = m_lsDeviceManager.begin(); iter != m_lsDeviceManager.end();iter++)
		{
			if (id == iter->first)
			{
				device = iter->second.m_cDeviceInformation;
				return 0;
			}
		}
		return 1;
	}

	int DeviceManager::GetUser(int id, UserManager **user)
	{
		for (ListDeviceManager::iterator iter = m_lsDeviceManager.begin(); iter != m_lsDeviceManager.end();iter++)
		{
			if (id == iter->first)
			{
				(*user) = &(iter->second.m_cUserManager);
				return 0;
			}
		}
		return 1;
	}

	int DeviceManager::Visit(IDeviceManagerVisitor	*pVisitor)
	{
		for (ListDeviceManager::iterator iter = m_lsDeviceManager.begin(); iter != m_lsDeviceManager.end();iter++)
		{
			pVisitor->DeviceManagerVisit(iter->first, iter->second.m_cDeviceInformation);
		}
		return 0;
	}

	int DeviceManager::CreateID(int &id)
	{
		while(true)
		{
			//ʶ
			if (CHECK_RET_FAILED(BuildID(id)))
			{
				return 1;
			}
			//֤ʶ
			if (CHECK_RET_SUCCESS(Search(id)))
			{
				//
				continue;
			}
			//ɳɹ
			return 0;
		}
		return 0;
	}

	int DeviceManager::BuildID(int &id)
	{
		//ʹʶ
		srand((DWORD)time(NULL));
		id = rand();
		if (0 == id)
		{
			//ʶΪ
			id += 1;
		}
		return 0;
	}

}
