
#include "../platform/win32/inc/stdafx.h"
#include "../inc/DownloadManager.h"

namespace structure
{

	DownloadInformation::DownloadInformation(const DownloadInformation &obj)
	{
		(*this) = obj;
	}

	DownloadInformation& DownloadInformation::operator=(const DownloadInformation &obj)
	{
		this->m_cDownloadFile = obj.m_cDownloadFile;
		this->m_cSaveFile = obj.m_cSaveFile;
		return (*this);
	}

	bool DownloadInformation::operator==(const DownloadInformation &obj)
	{
		if (this->m_cDownloadFile != obj.m_cDownloadFile ||
			this->m_cSaveFile != obj.m_cSaveFile)
		{
			return false;
		}
		return true;
	}

	//ع
	DownloadManager::DownloadManager()
	{
		m_lsManager.clear();
	}

	DownloadManager::~DownloadManager()
	{
		m_lsManager.clear();
	}

	int DownloadManager::Insert(HFILE_TRANSFER &id)
	{
		PairElement element;
		element.first = id;
		//
		m_lsManager.push_back(element);
		return 0;
	}

	int DownloadManager::Remove(HFILE_TRANSFER &id)
	{
		for (ListManager::iterator iter = m_lsManager.begin(); iter != m_lsManager.end();iter++)
		{
			if (id == iter->first)
			{
				m_lsManager.erase(iter);
				return 0;
			}
		}
		return 1;
	}

	int DownloadManager::GetInfo(HSTREAM id, DownloadInformation **info)
	{
		for (ListManager::iterator iter = m_lsManager.begin(); iter != m_lsManager.end();iter++)
		{
			if (id == iter->first)
			{
				(*info) = &(iter->second);
				return 0;
			}
		}
		return 1;
	}

	int DownloadManager::Visit(IDownloadManagerVisitor	*pVisitor)
	{
		for (ListManager::iterator iter = m_lsManager.begin(); iter != m_lsManager.end();iter++)
		{
			pVisitor->DownloadManagerVisitor(iter->first, iter->second);
		}
		return 0;
	}

}
