
#include "../platform/win32/inc/stdafx.h"
#include "../inc/RealStreamManager.h"
#include "../inc/VideoNetClientDemoDlg.h"

extern CVideoNetClientDemoDlg	*g_pMainDialog;

#include "../inc/Utility.h"
using namespace common;

namespace structure
{

	RealStreamInformation::RealStreamInformation(const RealStreamInformation &obj)
	{
		(*this) = obj;
	}

	RealStreamInformation& RealStreamInformation::operator=(const RealStreamInformation &obj)
	{
		this->m_FrameSerial = obj.m_FrameSerial;
		this->m_Channel = obj.m_Channel;
		this->m_Protocol = obj.m_Protocol;
		this->m_Stream = obj.m_Stream;
		this->m_cRecord = obj.m_cRecord;
		return (*this);
	}

	bool RealStreamInformation::operator==(const RealStreamInformation &obj)
	{
		if (this->m_FrameSerial != obj.m_FrameSerial ||
			this->m_Channel != obj.m_Channel ||
			this->m_Protocol != obj.m_Protocol ||
			this->m_Stream != obj.m_Stream ||
			this->m_cRecord != obj.m_cRecord)
		{
			return false;
		}
		return true;
	}

	RealStreamInfoManager& RealStreamInfoManager::operator=(const RealStreamInfoManager &obj)
	{
		this->m_StreamInfo = obj.m_StreamInfo;
		return (*this);
	}

	bool RealStreamInfoManager::operator==(const RealStreamInfoManager &obj)
	{
		if (this->m_StreamInfo == obj.m_StreamInfo)
		{
			return true;
		}
		return false;
	}

	//ʵʱ
	RealStreamManager::RealStreamManager()
	{
		m_lsRealStreamManager.clear();
	}

	RealStreamManager::~RealStreamManager()
	{
		m_lsRealStreamManager.clear();
	}

	int RealStreamManager::Insert(HUSER &id)
	{
		PairRealStream cRealStream;
		cRealStream.first = id;
		//豸
		m_lsRealStreamManager.push_back(cRealStream);
		return 0;
	}

	int RealStreamManager::Remove(HUSER &id)
	{
		for (ListRealStreamManager::iterator iter = m_lsRealStreamManager.begin(); iter != m_lsRealStreamManager.end();iter++)
		{
			if (id == iter->first)
			{
				m_lsRealStreamManager.erase(iter);
				return 0;
			}
		}
		return 1;
	}

	int RealStreamManager::Stream(HSTREAM id, char *buffer, int length)
	{
		for (ListRealStreamManager::iterator iter = m_lsRealStreamManager.begin(); iter != m_lsRealStreamManager.end();iter++)
		{
			if (id == iter->first)
			{
#if 0
				BYTE bytFrameType = 0;
				DWORD dwFrameSerial = 0;
				memcpy(&bytFrameType, buffer + 4, sizeof(bytFrameType));
				memcpy(&dwFrameSerial, buffer + 5, sizeof(dwFrameSerial));
				if (0x08 != bytFrameType)
				{
					if (0 != iter->second.m_StreamInfo.m_FrameSerial &&
						(iter->second.m_StreamInfo.m_FrameSerial + 1) != dwFrameSerial)
					{
						OUTPUT_MESSAGE("[Demo] RealStream Frame Number Error, before:%d current:%d\n",
							iter->second.m_StreamInfo.m_FrameSerial, dwFrameSerial);
					}
					iter->second.m_StreamInfo.m_FrameSerial = dwFrameSerial;
				}
				return 0;
#else
				/*
				typedef struct tagMP4DataPacketHeader
				{
					long DataPacketStartCode;
					BYTE FrameType;
					long FrameNo;
					UINT ShowTime;
					//BYTE LoadType;
					BYTE CodecType;
					int nOverloadLen;
				}DATAPACKETHEADER;
				*/
				if (CHECK_RET_FAILED(iter->second.m_StreamOutput.IsValid()))
				{
					if (0 == iter->second.m_StreamInfo.m_cRecord.size())
					{
						return 1;
					}
					if (CHECK_RET_FAILED(iter->second.m_StreamOutput.Open(iter->second.m_StreamInfo.m_cRecord, true)))
					{
						return 1;
					}
					CUtility	cUtility;
					char *header = NULL;
					int headlen = 0;
					cUtility.GetRecordFileHeader(&header, headlen);
					iter->second.m_StreamOutput.Output(header, headlen);
				}
				return iter->second.m_StreamOutput.Output(buffer, length);
#endif
			}
		}
		return 1;
	}

	int RealStreamManager::GetInfo(HSTREAM id, RealStreamInfoManager **RealStream)
	{
		for (ListRealStreamManager::iterator iter = m_lsRealStreamManager.begin(); iter != m_lsRealStreamManager.end();iter++)
		{
			if (id == iter->first)
			{
				(*RealStream) = &(iter->second);
				return 0;
			}
		}
		return 1;
	}

	int RealStreamManager::Visit(IRealStreamManagerVisitor	*pVisitor)
	{
		for (ListRealStreamManager::iterator iter = m_lsRealStreamManager.begin(); iter != m_lsRealStreamManager.end();iter++)
		{
			pVisitor->RealStreamManagerVisitor(iter->first, iter->second);
		}
		return 0;
	}

	//ʵʱת
	CycleRealStream::CycleRealStream()
	{
		m_interval = 0;
		for (int count = 0; count < ARRAY_ELEMENT_COUNT(m_stream); count++)
		{
			m_stream[count] = INVALID_HANDLE_VALUE;
		}
	}

	CycleRealStream::~CycleRealStream()
	{
		Stop();
	}

	int CycleRealStream::Start(DWORD interval)
	{
		if (0 == interval)
		{
			return 1;
		}
		if (0 != m_interval)
		{
			return 1;
		}
		m_interval = interval;
		return m_thread.Start(this);
	}

	int CycleRealStream::Stop()
	{
		if (0 == m_interval)
		{
			return 1;
		}
		m_thread.Stop();
		for (int count = 0; count < MAX_CHANNEL_NUMBER; count++)
		{
			g_pMainDialog->RealStreamDisconnect(m_stream[count]);
			m_stream[count] = INVALID_HANDLE_VALUE;
		}
		m_interval = 0;
		return 0;
	}

	//ִ߳
	int CycleRealStream::execute()
	{
		RealStreamPara	para;
		para.dwChannel = m_information.m_Channel;
		para.eTransferMode = (eStreamTransferMode)(m_information.m_Protocol);
		para.eMediaType = (eStreamMediaType)(m_information.m_Stream + 1);
		if (MAX_CHANNEL_NUMBER == m_information.m_Channel)
		{
			for (int count = 0; count < MAX_CHANNEL_NUMBER; count++)
			{
				para.dwChannel = count;
				g_pMainDialog->RealStreamConnect(m_stream[count], m_user, &para);
			}
		}else{
			g_pMainDialog->RealStreamConnect(m_stream[0], m_user, &para);
		}
		Sleep(m_interval);
		if (MAX_CHANNEL_NUMBER == m_information.m_Channel)
		{
			for (int count = 0; count < MAX_CHANNEL_NUMBER; count++)
			{
				g_pMainDialog->RealStreamDisconnect(m_stream[count]);
				m_stream[count] = INVALID_HANDLE_VALUE;
			}
		}else{
			g_pMainDialog->RealStreamDisconnect(m_stream[0]);
			m_stream[0] = INVALID_HANDLE_VALUE;
		}
		return 0;
	}

	int CycleRealStream::SetInformation(HUSER user, RealStreamInformation &information)
	{
		if (0 != m_interval)
		{
			return 1;
		}
		m_user = user;
		m_information = information;
		return 0;
	}

	//
	int CycleRealStream::CheckStream(HSTREAM stream)
	{
		if (0 == m_interval)
		{
			return 1;
		}
		for (int count = 0; count < MAX_CHANNEL_NUMBER; count++)
		{
			if (stream == m_stream[count])
			{
				return 0;
			}
		}
		return 1;
	}

}
