
#include "../platform/win32/inc/stdafx.h"
#include "../inc/TalkStreamManager.h"
#include "../inc/VideoNetClientDemoDlg.h"

extern CVideoNetClientDemoDlg	*g_pMainDialog;

namespace structure
{

	TalkStreamInformation::TalkStreamInformation(const TalkStreamInformation &obj)
	{
		(*this) = obj;
	}

	TalkStreamInformation& TalkStreamInformation::operator=(const TalkStreamInformation &obj)
	{
		this->m_Protocol = obj.m_Protocol;
		this->m_cRecvFile = obj.m_cRecvFile;
		this->m_cSendFile = obj.m_cSendFile;
		return (*this);
	}

	bool TalkStreamInformation::operator==(const TalkStreamInformation &obj)
	{
		if (this->m_Protocol != obj.m_Protocol ||
			this->m_cRecvFile != obj.m_cRecvFile ||
			this->m_cSendFile != obj.m_cSendFile)
		{
			return false;
		}
		return true;
	}

	TalkStreamInfoManager& TalkStreamInfoManager::operator=(const TalkStreamInfoManager &obj)
	{
		this->m_StreamInfo = obj.m_StreamInfo;
		this->m_hStream = obj.m_hStream;
		return (*this);
	}

	bool TalkStreamInfoManager::operator==(const TalkStreamInfoManager &obj)
	{
		if (this->m_StreamInfo == obj.m_StreamInfo && this->m_hStream == obj.m_hStream)
		{
			return true;
		}
		return false;
	}

	//
	int TalkStreamInfoManager::Start()
	{
		FILE *file = fopen(m_StreamInfo.m_cSendFile.c_str(), "r");
		if (CHECK_POINT_NULL(file))
		{
			return 1;
		}
		fclose(file);
		return m_SendThread.Start(this);
	}

	//ֹͣ
	int TalkStreamInfoManager::Stop()
	{
		return m_SendThread.Stop();
	}

	//ִ߳
	int TalkStreamInfoManager::execute()
	{
		FILE *file = fopen(m_StreamInfo.m_cSendFile.c_str(), "r");
		if (CHECK_POINT_NULL(file))
		{
			return 1;
		}
		BYTE buffer[MAX_TALK_FRAME_LEN];
		DWORD count = 0;
		while (0 != (count = fread(buffer, 1, MAX_TALK_FRAME_LEN, file)))
		{
			g_pMainDialog->TalkSend(m_hStream, buffer, count);
		}
		fclose(file);
		return 1;
	}

	//ʵʱ
	TalkStreamManager::TalkStreamManager()
	{
		m_lsTalkStreamManager.clear();
	}

	TalkStreamManager::~TalkStreamManager()
	{
		m_lsTalkStreamManager.clear();
	}

	int TalkStreamManager::Insert(HSTREAM &id)
	{
		PairTalkStream cTalkStream;
		cTalkStream.first = id;
		//豸
		m_lsTalkStreamManager.push_back(cTalkStream);
		return 0;
	}

	int TalkStreamManager::Remove(HSTREAM &id)
	{
		for (ListTalkStreamManager::iterator iter = m_lsTalkStreamManager.begin(); iter != m_lsTalkStreamManager.end();iter++)
		{
			if (id == iter->first)
			{
				m_lsTalkStreamManager.erase(iter);
				return 0;
			}
		}
		return 1;
	}

	int TalkStreamManager::Stream(HSTREAM id, char *buffer, int length)
	{
		for (ListTalkStreamManager::iterator iter = m_lsTalkStreamManager.begin(); iter != m_lsTalkStreamManager.end();iter++)
		{
			if (id == iter->first)
			{
				if (CHECK_RET_FAILED(iter->second.m_StreamOutput.IsValid()))
				{
					if (0 == iter->second.m_StreamInfo.m_cRecvFile.size())
					{
						return 1;
					}
					if (CHECK_RET_FAILED(iter->second.m_StreamOutput.Open(iter->second.m_StreamInfo.m_cRecvFile, true)))
					{
						return 1;
					}
				}
				return iter->second.m_StreamOutput.Output(buffer, length);
			}
		}
		return 1;
	}

	int TalkStreamManager::GetInfo(HSTREAM id, TalkStreamInfoManager **TalkStream)
	{
		for (ListTalkStreamManager::iterator iter = m_lsTalkStreamManager.begin(); iter != m_lsTalkStreamManager.end();iter++)
		{
			if (id == iter->first)
			{
				(*TalkStream) = &(iter->second);
				return 0;
			}
		}
		return 1;
	}

	int TalkStreamManager::Visit(ITalkStreamManagerVisitor	*pVisitor)
	{
		for (ListTalkStreamManager::iterator iter = m_lsTalkStreamManager.begin(); iter != m_lsTalkStreamManager.end();iter++)
		{
			pVisitor->TalkStreamManagerVisitor(iter->first, iter->second);
		}
		return 0;
	}

}
