#include "../platform/win32/inc/stdafx.h"
#include "../inc/VideoNetClientDemo_Common.h"
#include "../inc/Thread.h"

namespace	common
{

	CThread::CThread(void)
	{
		m_bRun = false;
		m_execute = NULL;
		m_hThread = NULL;
		m_dwThreadID = 0;
	}

	CThread::~CThread(void)
	{
		m_bRun = false;
		m_execute = NULL;
		m_hThread = NULL;
		m_dwThreadID = 0;
	}

	//߳
	int CThread::Start(IThreadExecute	*execute)
	{
		if (m_bRun || CHECK_POINT_NULL(execute))
		{
			return 1;
		}
		m_bRun = true;
		m_execute = execute;
		m_hThread = ::CreateThread(NULL, 0, ThreadRun, this, 0, &m_dwThreadID);
		if (CHECK_POINT_NULL(m_hThread))
		{
			return 1;
		}
		return 0;
	}

	//ֹͣ߳
	int CThread::Stop()
	{
		if (!m_bRun)
		{
			return 1;
		}
		m_bRun = false;
		::WaitForSingleObject(m_hThread, INFINITE);
		::CloseHandle(m_hThread);
		m_hThread = NULL;
		m_execute = NULL;
		m_dwThreadID = 0;
		return 0;
	}

	DWORD WINAPI CThread::ThreadRun(void *para)
	{
		CThread *pThis = (CThread*)para;
		if (CHECK_POINT_NULL(pThis) || CHECK_POINT_NULL(pThis->m_execute))
		{
			return 1;
		}
		while(pThis->m_bRun)
		{
			if (0 != pThis->m_execute->execute())
			{
				return 1;
			}
		}
		return 0;
	}

}
