
#include "../platform/win32/inc/stdafx.h"
#include "../inc/TransparentManager.h"
#include "../inc/VideoNetClientDemoDlg.h"

extern CVideoNetClientDemoDlg	*g_pMainDialog;

namespace structure
{

	TransparentInformation::TransparentInformation(const TransparentInformation &obj)
	{
		(*this) = obj;
	}

	TransparentInformation& TransparentInformation::operator=(const TransparentInformation &obj)
	{
		this->m_ChannelType = obj.m_ChannelType;
		this->m_SerialPort = obj.m_SerialPort;
		this->m_SerialType = obj.m_SerialType;
		this->m_cRecvFile = obj.m_cRecvFile;
		this->m_cSendFile = obj.m_cSendFile;
		return (*this);
	}

	bool TransparentInformation::operator==(const TransparentInformation &obj)
	{
		if (this->m_ChannelType != obj.m_ChannelType ||
			this->m_SerialPort != obj.m_SerialPort ||
			this->m_SerialType != obj.m_SerialType ||
			this->m_cRecvFile != obj.m_cRecvFile ||
			this->m_cSendFile != obj.m_cSendFile)
		{
			return false;
		}
		return true;
	}

	TransparentInfoManager& TransparentInfoManager::operator=(const TransparentInfoManager &obj)
	{
		this->m_StreamInfo = obj.m_StreamInfo;
		this->m_hStream = obj.m_hStream;
		return (*this);
	}

	bool TransparentInfoManager::operator==(const TransparentInfoManager &obj)
	{
		if (this->m_StreamInfo == obj.m_StreamInfo && this->m_hStream == obj.m_hStream)
		{
			return true;
		}
		return false;
	}

	//
	int TransparentInfoManager::Start()
	{
		FILE *file = fopen(m_StreamInfo.m_cSendFile.c_str(), "rb");
		if (CHECK_POINT_NULL(file))
		{
			return 1;
		}
		fclose(file);
		return m_SendThread.Start(this);
	}

	//ֹͣ
	int TransparentInfoManager::Stop()
	{
		return m_SendThread.Stop();
	}

	//ִ߳
	int TransparentInfoManager::execute()
	{
		FILE *file = fopen(m_StreamInfo.m_cSendFile.c_str(), "rb");
		if (CHECK_POINT_NULL(file))
		{
			return 1;
		}
		BYTE buffer[MAX_TRANSPARENT_SEND_BUFFER];
		DWORD count = 0;
		while (0 != (count = fread(buffer, 1, MAX_TRANSPARENT_SEND_BUFFER, file)))
		{
			g_pMainDialog->TransparentSend(m_hStream, buffer, count);
		}
		fclose(file);
		return 1;
	}

	//͸ͨ
	TransparentManager::TransparentManager()
	{
		m_lsManager.clear();
	}

	TransparentManager::~TransparentManager()
	{
		m_lsManager.clear();
	}

	int TransparentManager::Insert(HTRANSPARENT &id)
	{
		PairElement element;
		element.first = id;
		//豸
		m_lsManager.push_back(element);
		return 0;
	}

	int TransparentManager::Remove(HTRANSPARENT &id)
	{
		for (ListManager::iterator iter = m_lsManager.begin(); iter != m_lsManager.end();iter++)
		{
			if (id == iter->first)
			{
				m_lsManager.erase(iter);
				return 0;
			}
		}
		return 1;
	}

	int TransparentManager::Stream(HTRANSPARENT id, char *buffer, int length)
	{
		for (ListManager::iterator iter = m_lsManager.begin(); iter != m_lsManager.end();iter++)
		{
			if (id == iter->first)
			{
				if (CHECK_RET_FAILED(iter->second.m_StreamOutput.IsValid()))
				{
					if (0 == iter->second.m_StreamInfo.m_cRecvFile.size())
					{
						return 1;
					}
					if (CHECK_RET_FAILED(iter->second.m_StreamOutput.Open(iter->second.m_StreamInfo.m_cRecvFile,true)))
					{
						return 1;
					}
				}
				return iter->second.m_StreamOutput.Output(buffer, length);
			}
		}
		return 1;
	}

	int TransparentManager::GetInfo(HSTREAM id, TransparentInfoManager **info)
	{
		for (ListManager::iterator iter = m_lsManager.begin(); iter != m_lsManager.end();iter++)
		{
			if (id == iter->first)
			{
				(*info) = &(iter->second);
				return 0;
			}
		}
		return 1;
	}

	int TransparentManager::Visit(ITransparentManagerVisitor	*pVisitor)
	{
		for (ListManager::iterator iter = m_lsManager.begin(); iter != m_lsManager.end();iter++)
		{
			pVisitor->TransparentManagerVisitor(iter->first, iter->second);
		}
		return 0;
	}

}
